#!/usr/bin/perl

#--------ライブラリ読込み------------------------

if(!-e 'lib/conf.pl'){
	&error("conf.plがありません。");
}
require 'lib/conf.pl';

if(!-e 'lib/conf2.cgi'){
	&error("conf2.cgiがありません。");
}
require 'lib/conf2.cgi';

if(!-e 'lib/passwd.cgi'){
	&error("passwd.cgiがありません。");
}
require 'lib/passwd.cgi';

if(!-e 'lib/functions.pl'){
	&error("functions.plがありません。");
}
require 'lib/functions.pl';

#-------変数-------------------------------------

$script='';
$master='たぬき';	#投稿者に表示する名前
$adminpagemax=10;


$intvl=3;		#ページを作る間隔(秒)
$makenum=31;		#一度につくるページ数
$imgviewpagemax=6;
$upnum=6;	#アップする画像の数
$c_valid=365;
$counterlog='log/counter.log';

#----------------------------------------------

if(!&SuCheck){
	$su=0;
}

$maxsize=500000;

$FORM{'name'}=$master;
$FORM{'page'}=0;


if($ENV{'CONTENT_TYPE'}=~/multi/){
	&DecodeMulti;
}
else{
	&Decode;
}

sub DecodeMulti{
my($ref,$in_ref,$incfn_ref,$inct_ref,
$name,$value,
$o,$d,$upflag,$upnflag,$filename,$ctype,$okflag,
$csvfilename,$t_fname,$na,@tmp,$ext,$imgfilename,$upidx
);

unless(-e "lib/cgi_lib.pl"){
	&error("cgi_lib.plがありません。");
}
require 'lib/cgi_lib.pl';

($ref,$in_ref,$incfn_ref,$inct_ref)=&ReadParse;
$upidx=0;
foreach $name(@{$ref}){
	if ($name !~/^upfile/) {
		$value=${$in_ref}{$name};
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		if($name eq "message" || $name eq "tmpmsg"){
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		else{
			$value=~s/</&lt;/g;
			$value=~s/>/&gt;/g;
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		$FORM{$name}=$value;
	}
	else{
		$upflag=0;
		$upnflag=0;
		$filename="";
		$ctype="";
		$okflag=0;
		$upnflag=1;
		$filename=${$incfn_ref}{$name};
		$ctype=${$inct_ref}{$name};
		$CTYPE{$name}=$ctype;
		if($filename){
			$ext=&FileType($ctype);
			if(!$ext){
				&error("アップロードできないファイル形式です。");
			}
			$imgfile=time.$$.'.'.$ext;
			$name_d=$name;
			$name_d=~s/upfile//;
			$imgfilename = $tmpimgdir.$imgfile;
			$UPFNAME[$upidx]=$imgfile;
			$upidx++;
			$FNAME{$name_d}=$filename;
			unless(open(IMAGE,">$imgfilename")){
				&error("画像のアップロードに失敗しました");
			}
			binmode(IMAGE);
			binmode(STDOUT);
			print IMAGE ${$in_ref}{$name};
			close(IMAGE);
			$upflag=1;
		}
	}
}

}



sub Decode{
my($name,$value,$buff,@pairs,$pair);

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'} > $maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	@pairs=split(/&/,$buff);
	foreach $pair(@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		if($name eq "message" || $name eq "tmpmsg"){
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		else{
			$value=~s/"/&quot;/g;
			$value=~s/</&lt;/g;
			$value=~s/>/&gt;/g;
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		if($name eq "delnum"){
			push @delnum,$value;
		}
		elsif($name eq "touroku"){
			push @touroku,$value;
		}
		elsif($name=~/^ico_/){
			push @icon_n,$value;
		}
		elsif($name=~/^isetu_/){
			push @isetu,$value;
		}
		elsif($name=~/^col_/){
			push @color_v,$value;
		}
		$FORM{$name}=$value;
	}
}

}

if($FORM{'mode'}=~/^entry/){
	if(!-e 'lib/admin/entry.pl'){
		&error('entry.plがありません。');
	}
	require 'lib/admin/entry.pl';
}
elsif($FORM{'mode'}=~/^trackback/){
	if(!-e 'lib/admin/tb.pl'){
		&error('tb.plがありません。');
	}
	require 'lib/admin/tb.pl';
}
elsif($FORM{'mode'}=~/^comment/){
	if(!-e 'lib/admin/com.pl'){
		&error('com.plがありません。');
	}
	require 'lib/admin/com.pl';
}
elsif($FORM{'mode'}=~/^category/){
	if(!-e 'lib/admin/cate.pl'){
		&error('cate.plがありません。');
	}
	require 'lib/admin/cate.pl';
}
elsif($FORM{'mode'}=~/^temp/){
	if(!-e 'lib/admin/temp.pl'){
		&error('temp.plがありません。');
	}
	require 'lib/admin/temp.pl';
}
elsif($FORM{'mode'}=~/^comtemp/){
	if(!-e 'lib/admin/comtemp.pl'){
		&error('comtemp.plがありません。');
	}
	require 'lib/admin/comtemp.pl';
}
elsif($FORM{'mode'}=~/^yeardel/ || $FORM{'mode'}=~/^rebuild/ || $FORM{'mode'}=~/^ccheck/){
	if(!-e 'lib/admin/rebuild.pl'){
		&error('rebuild.plがありません。');
	}
	require 'lib/admin/rebuild.pl';
}
elsif($FORM{'mode'}=~/^img/){
	if(!-e 'lib/admin/img.pl'){
		&error('img.plがありません。');
	}
	require 'lib/admin/img.pl';
}

if($FORM{'mode'} eq "categoryedit"){
	if($FORM{'edit'} eq '削除'){
		$FORM{'mode'}='categorydel';
	}
}
elsif($FORM{'mode'} eq "trackbackedit"){
	if($FORM{'edit'} eq '削除'){
		$FORM{'mode'}='trackbackdel';
	}
}

if($FORM{'mode'}=~/regist$/ || $FORM{'mode'}=~/del$/ || $FORM{'mode'}=~/^entrypre/ || $FORM{'mode'}=~/^yeardel/ || $FORM{'mode'}=~/^rebulid/){
	if(!-e 'lib/makepage.pl'){
		&error('makepage.plがありません。');
	}
	require 'lib/makepage.pl';
}


if($ENV{'SCRIPT_NAME'}){
	$c_name=$ENV{'SCRIPT_NAME'};
}
else{
	$c_name="mdiary";
}


if($FORM{'mode'} eq "entryform"){
	&EntryForm;
}
elsif($FORM{'mode'} eq "entryregist"){
	&EntryRegist;
}
elsif($FORM{'mode'} eq "entry"){
	&Entry;
}
elsif($FORM{'mode'} eq "entrydel"){
	&EntryDel;
}
elsif($FORM{'mode'} eq "entryedit"){
	&EntryEdit;
}
elsif($FORM{'mode'} eq "entryeditregist"){
	&EntryEditRegist;
}
elsif($FORM{'mode'} eq "entrypremakear"){
	&PreMakeAr;
}
elsif($FORM{'mode'} eq "entrypreview"){
	&Preview;
}
elsif($FORM{'mode'} eq "trackback"){
	&TrackBack;
}
elsif($FORM{'mode'} eq "trackbackdel"){
	&TrackBackDel;
}
elsif($FORM{'mode'} eq "trackbackedit"){
	&TrackBackEdit;
}
elsif($FORM{'mode'} eq "trackbackeditregist"){
	&TrackBackEditRegist;
}
elsif($FORM{'mode'} eq "comment"){
	&Comment;
}
elsif($FORM{'mode'} eq "commentdel"){
	&CommentDel;
}
elsif($FORM{'mode'} eq "commentedit"){
	&CommentEdit;
}
elsif($FORM{'mode'} eq "commenteditregist"){
	&CommentEditRegist;
}
elsif($FORM{'mode'} eq "category"){
	&Category;
}
elsif($FORM{'mode'} eq "categoryadd"){
	&CategoryAdd;
}
elsif($FORM{'mode'} eq "categorydel"){
	&CategoryDel;
}
elsif($FORM{'mode'} eq "categoryedit"){
	&CategoryEdit;
}
elsif($FORM{'mode'} eq "categoryeditregist"){
	&CategoryEditRegist;
}
elsif($FORM{'mode'} eq "menu"){
	&Menu;
}
elsif($FORM{'mode'} eq "imgupload"){
	&ImgUpload;
}
elsif($FORM{'mode'} eq "imgview"){
	&ImgView;
}
elsif($FORM{'mode'} eq "imgviewpre"){
	&ImgViewPre;
}
elsif($FORM{'mode'} eq "imgdel"){
	&ImgDel;
}
elsif($FORM{'mode'} eq "imgpage"){
	&ImgPage;
}
elsif($FORM{'mode'} eq "yeardel"){
	&YearDel;
}
elsif($FORM{'mode'} eq "yeardeldo"){
	&YearDelDo;
}
elsif($FORM{'mode'} eq "rebuildready"){
	&RebuildReady("page");
}
elsif($FORM{'mode'} eq "ccheck"){
	&CCheck;
}
elsif($FORM{'mode'} eq "ccheckdo"){
	&CcheckDo;
}
elsif($FORM{'mode'} eq "rebuild"){
	&Rebuild;
}
elsif($FORM{'mode'} eq "rebuildregist"){
	&RebuildRegist;
}
elsif($FORM{'mode'} eq "top"){
	&Top;
}
elsif($FORM{'mode'} eq "temp"){
	&Temp;
}
elsif($FORM{'mode'} eq "comtemptop"){
	&ComTempTop;
}
elsif($FORM{'mode'} eq "comtempregist"){
	if($FORM{'act'} eq "登録"){
		&ComTempRegist;
	}
	else{
		&ComTempDel;
	}
}
elsif($FORM{'mode'} eq "templist"){
	&TempList;
}
elsif($FORM{'mode'} eq "tempreg"){
	&TempReg;
}
elsif($FORM{'mode'} eq "tempdel"){
	&TempDel;
}
elsif($FORM{'mode'} eq "env"){
	&Env;
}
elsif($FORM{'mode'} eq "envregist"){
	&EnvRegist;
}

else{
	&Login;
}


sub GetCookie{
my($name,$value,$pair,@pairs,$cookies);
$cookies=$ENV{'HTTP_COOKIE'};
@pairs=split(/;/,$cookies);
foreach $pair(@pairs){
	($name, $value)=split(/=/,$pair);
	$name=~s/ //g;
	$DUMMY{$name}=$value;
}
$DUMMY{$c_name}=~ s/\+/ /g;
$DUMMY{$c_name}=~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
@pairs=split(/,/,$DUMMY{$c_name});
foreach $pair(@pairs){
	($name, $value)=split(/\:/,$pair);
	$COOKIE{$name}=$value;
}
}

sub SetCookie{
my($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg,
$timer,$date_gmt,$cook,@month,@week,
);
$timer=time;
($secg, $ming, $hourg, $mdayg, $mong, $yearg, $wdayg, $ydayg, $isdstg)=gmtime($timer+$c_valid*24*60*60);
@month=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date_gmt=sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",$week[$wdayg],$mdayg,$month[$mong],$yearg+1900,$hourg,$ming,$secg);
$cook="pass:$FORM{'pass'}";
$cook=~s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
$cook=~tr/ /+/;
print "Set-Cookie: $c_name=$cook; expires=$date_gmt\n";
}

sub DelCookie{
print "Set-Cookie: $c_name=;\n";
}

sub FileType{
my(%type,$t,$tt,@tmp);
$t=$_[0];

if($t eq ""){
	return;
}

@tmp=split(/\//,$t);
$t=$tmp[$#tmp];

%type=(
'pjpeg'=>'jpg',
'jpeg'=>'jpg',
'gif'=>'gif',
);

if($type{$t}){
	$tt=$type{$t};
}
else{
	$tt="";
}
return $tt;
}


sub Login{
my($ck,$ok);

&GetCookie;

if($COOKIE{'pass'}){
	$ck=" checked";
	$ok="1";
}

&header;

print <<EOM;
<br>
<br>
<br>
<div align=center>
<form method="POST" action="">
<input type="hidden" name="mode" value="entryform">
<input type="hidden" name="ok" value="$ok">
<table>
<tr>
<td>パスワード</td>
<td><input size="8" type="password" name="pass" maxlength="8" value="$COOKIE{'pass'}"></td>
<td><input type="submit" value="ログイン"></td>
</tr>
<tr>
<td></td>
<td><input type="checkbox" name="cookie" value="1"$ck>クッキー</td>
<td></td>
</tr>
</table>

</form>
</div>
</body>
</html>
EOM
exit;

}



sub checkpass{
my($fopass,$passflag);
if($passwd eq ""){
	&error("パスワードが設定されていません。");
}
$fopass=$_[0];
if($passwd eq 'admin'){
	if($fopass ne $passwd){
		&error("パスワードが違います。");
	}
}
else{
	$passflag=&MatchPass($fopass,$passwd);
	if(!$passflag){
		&error("パスワードが違います。");
	}
}
return;
}

sub Table1{
my($line,$date,$count_tday,$count_yday,$total,$cline);

print <<EOM;
<table width="1000" border="0">
<tr>
<td width="140" valign="top">
EOM

if(($countway == 1) || ($countway == 3)){
	unless(open(CLOG,$counterlog)){
		&error("counterlogが開けません。");
	}
	$line=<CLOG>;
	close CLOG;
	($date,$count_tday,$count_yday,$total)=split(/,/,$line);
	if($count_yday eq ""){
		$count_yday=0;
	}
	if($count_tday eq ""){
		$count_tday=0;
	}
	if($total eq ""){
		$total=0;
	}
	if($d_format){
		$count_tday=sprintf("%0${d_digit}d",$count_tday);
		$count_yday=sprintf("%0${d_digit}d",$count_yday);
	}
	if($c_way == 0){
		$cline=$total;
	}
	elsif($c_way == 1){
		$cline=qq(T:$count_tday Y:$count_yday);
	}
	else{
		$cline=qq($total T:$count_tday Y:$count_yday);
	}
}

&PrintMenu;

print "<table cellpadding=\"3\"><tr><td>$cline</td></tr></table>";

print <<EOM;
</td>
<td align="center" valign="top">
EOM
}

sub Table2{
print <<EOM;
</td>
</tr>
</table>
EOM
}

sub PrintMenu{

print <<EOM;
<table class="menutbl">
<tr>
<td>
<table cellpadding="3">
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('entryform');">記事の投稿</a></td>
</tr>
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('entry');">記事の削除・編集</a></td>
</tr>
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('templist');">仮投稿の記事</a></td>
</tr>
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('comment');">コメント</a></td>
</tr>
EOM

if($rescheck){
print <<EOM;
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('comtemptop');">仮投稿のコメント</a></td>
</tr>
EOM
}

if($tbuse){
print <<EOM;
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('trackback');">トラックバック</a></td>
</tr>
EOM
}


print <<EOM;
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('category');">カテゴリ</a></td>
</tr>
<tr>
<td>・<a href="javascript:void(0);" onclick="Move('env');">環境設定</a></td>
</tr>
<tr>
<td>・<a href="javascript:void(0)" onclick="Tree('snt')">その他</a>
<div id="snt" style="display:none;padding:2px 0px 0px 4px;line-height:130%">
├<a href="javascript:void(0);" onclick="Move_o('rebuildready',400,600);">再構\築</a><br>
├<a href="javascript:void(0);" onclick="Move_o('ccheck',400,400);">カウントチェック</a><br>
└<a href="javascript:void(0);" onclick="Move_o('yeardel',400,500);">年・月ごとの削除</a><br>

</div>

</td>
</tr>
</table>
</td>
</tr>
</table>

<form name="fomove" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="mode" value="">
<input type="hidden" name="pass" value="$FORM{'pass'}">
</form>
<form name="fomove_o" method="POST" action="$script" style="margin:0px" target="s_win">
<input type="hidden" name="mode" value="">
<input type="hidden" name="pass" value="$FORM{'pass'}">
</form>
<form name="fomove_page" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="mode" value="">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="page" value="">
<input type="hidden" name="timer" value="">
</form>
<script type="text/javascript">
function Move(m){
document.fomove.mode.value=m;
document.fomove.submit();
}

function Move_o(m,w,h){
openwin('',w,h);
document.fomove_o.mode.value=m;
document.fomove_o.submit();
}

function Move_page(m,page,timer){
document.fomove_page.mode.value=m;
document.fomove_page.page.value=page;
document.fomove_page.timer.value=timer;
document.fomove_page.submit();
}
</script>
EOM


}


#--------------------------------------

sub SetCal{
my($year,$mon,$h,@days,$last,$first);
$year=$_[0];
$mon=$_[1];

@days = (31,28,31,30,31,30,31,31,30,31,30,31);
if( (($year%4 ==0)&&($year%100 != 0))||($year%400 == 0) ){
	$days[1]=29;
}
$last=$days[$mon-1];
$first=&Wday($year,$mon,1);
$h=$first.":".$last;
return $h;
}

sub Wday{
my($year,$month,$day);
($year,$month,$day)=@_;
if($month<3){
	$month+=12;
	$year--;
}
return ($year+int($year/4)-int($year/100)+int($year/400)+int((13*$month+8)/5)+$day)% 7;
}


#?entry bu
sub UnlinkEntry{
my($ref,$y,$m,@dirarray,%count,$entry_html,$no,$year,$mon,$dir);

$ref=$_[0];

if(!scalar(@{$ref})){
	return;
}

if($entrymode){
	foreach(@{$ref}){
		($no,$m)=split(/_/,$_);
		$year=substr($m,0,4);
		$mon=substr($m,4,2);
		if($su){
			$entry_html=$entrydir.$year."/".$mon."/"."$no$htmlext";
			$dir=$entrydir.$year."/".$mon."/";
			push @dirarray,$dir;
		}
		else{
			$entry_html="$entrydir/$no$htmlext";
		}
		if(-e $entry_html){
			unlink $entry_html || &error("$entry_htmlが削除できません。");
		}
	}
}
if($su){
	@dirarray= grep(!$count{$_}++, @dirarray);
	foreach(@dirarray){
		&EmptyCheck($_);
	}
}
}


#?entry
sub UnlinkCalEn{
my($ref,$y,$m,$dir,$file,$yr,$mn);

$ref=$_[0];
$m=$_[1];

$yr=substr($m,0,4);
$mn=substr($m,4,2);

$dir=$caldir.$yr."/".$mn;

foreach(@{$ref}){
	$file=$caldir.$yr."/".$mn."/".$_.$htmlext;
	if(-e $file){
		unlink $file || &error("$fileが削除できません。");
	}
	&EmptyCheck($dir);
}

}


#?en bu
sub DelAr{
my($ref,$flag,@new,@un,@ok,$num,$dnum,$flag2,$n,$m,$idx);

$ref=$_[0];
$flag=0;
$flag2=0;
unless(open(FILE,$arlog)){
	&error("arlogが開けません。a2");
}
$idx=0;

while(<FILE>){
	($m,$n)=split(/,/,$_);
	$flag=0;
	if(${$ref}{$m}){
		$n-=${$ref}{$m};
		if($n < 0){
			$n=0;
		}
		if($n == 0){
			$flag=1;
			push @un,"$m,$n";
		}
		else{
			push @ok,$m;
		}
		$_="$m,$n,\n";
		if(!$flag2){
			$flag2=1;
		}
	}
	if(!$flag){
		$new[$idx++]=$_;
	}
}
close FILE;

if(!$flag2){
	return;
}


unless(open(FILE,">$arlog")){
	&error("arlogが開けません。a3");
}
print FILE @new;
close FILE;

foreach(@un){
	($dnum,$num)=split(/,/,$_);
	&UnlinkAr($dnum,$num);
}

return(\@ok);

}

sub UnlinkAr{
my($i,$num,$mm,$file,$s,$wari,$amari);
$mm=$_[0];
$num=$_[1];

if($pagemax){
	$wari=int($num/$pagemax);
	$amari=$num%$pagemax;
	if($amari){
		$wari++;
	}
}
if(!$wari){
	$wari=1;
}

for($i=1;$i<=$wari;$i++){
	if($i > 1){
		$s="_".$i;
	}
	else{
		$s="";
	}
	$file=$ardir.$mm.$s.$htmlext;
	if(-e $file){
		unlink $file || &error("$fileが削除できません。");
	}
}


}


#?com en tb bu
sub DelCount{
my($act,$n,$dum,$ecnt,$ccnt,$tcnt);

$act=$_[0];
$n=$_[1];

unless(open(FILE,$countlog)){
	&error("countlogが開けません。a4");
}
$dum=<FILE>;
close FILE;

($ecnt,$ccnt,$tcnt)=split(/,/,$dum);

if($act eq "entry"){
	$ecnt-=$n;
	if($ecnt < 0){
		$ecnt=0;
	}
}
elsif($act eq "com"){
	$ccnt-=$n;
	if($ccnt < 0){
		$ccnt=0;
	}
}
if($act eq "tb"){
	$tcnt-=$n;
	if($tcnt < 0){
		$tcnt=0;
	}
}

unless(open(FILE,">$countlog")){
	&error("countlogに書き込めません。パーミッション等を確認してください。");
}
print FILE "$ecnt,$ccnt,$tcnt,\n";
close FILE;

}

#com tb en
sub inhash{
my(
@tmp,$no,$page_id,%ARY,
$flag,$j,$v,$ref,$target,$mode,$d,$tnum,@t,$i,$deli
);

$ref=$_[0];
$tnum=$_[1];
$deli=$_[2];

$i=1;
@tmp=();
foreach(@{$ref}){
	@t=split(/$deli/,$_);
	$target=$t[$tnum];
	if($i==1){
		push @tmp,$target;
		push @{$ARY{$target}},$_;
	}
	else{
		$flag=0;
		$j=1;
		foreach $v(@tmp){
			if($target eq $v){
				$flag=1;
				last;
			}
			$j++;
		}
		if(!$flag){
			push @tmp,$target;
		}
		push @{$ARY{$target}},$_;
	}
	$i=2;
}

return(\%ARY,\@tmp);

}

sub inhash2{
my(%CNT,$ref,$y,$m,@tmp,$arraynum,$i);
$ref=$_[0];

$i=1;
$arraynum=1;
@tmp=();
foreach(@{$ref}){
	$CNT{$_}++;
}

return(\%CNT);

}



#?en bu
sub DelEntryTop{
my(
$ref,$flag,$l,$id,@new,$flag2,$idx,$id_d,$no_d,$m
);

$ref=$_[0];
$flag2=0;
$idx=0;
unless(open(FILE,$entrylog)){
	&error("entrylogが開けません。a5");
}
while(<FILE>){
	($id)=split(/,/,$_);
	$flag=0;
	foreach $l(@{$ref}){
		($no_d,$m)=split(/_/,$l);
		$id_d=$m.$no_d;
		if($id == $id_d){
			$flag=1;
			if(!$flag2){
				$flag2=1;
			}
			last;
		}
	}
	if(!$flag){
		$new[$idx++]=$_;
	}
}

if(!$flag2){
	return;
}

unless(open(FILE,">$entrylog")){
	&error("$entrylogが開けません。a6");
}
print FILE @new;
close FILE;


}


#?com en bu
sub DelComTop{
my(
$ref,$flag,$l,@new,$id,$flag2,$ln,$mode,$d,$m,$id_d,$idx,$n,$no
);
$mode=$_[0];
$ref=$_[1];
$flag2=0;
if($mode eq "com"){
	unless(open(FILE,$comlog)){
		&error("comlogが開けません。a7");
	}
	$idx=0;
	while($ln=<FILE>){
		($id,$no)=split(/,/,$ln);
		$flag=0;
		foreach $l(@{$ref}){
			($d,$n,$m)=split(/_/,$l);
			$id_d=$m.$d;
			if(($id == $id_d) && ($no == $n)){
				$flag=1;
				if(!$flag2){
					$flag2=1;
				}
				last;
			}
		}
		if(!$flag){
			$new[$idx++]=$ln;
		}
	}
	close FILE;
}
else{
	unless(open(FILE,$comlog)){
		&error("comllogが開けません。");
	}
	$idx=0;
	while($ln=<FILE>){
		($id,$no)=split(/,/,$ln);
		$flag=0;
		foreach $l(@{$ref}){
			($d,$m)=split(/_/,$l);
			$id_d=$m.$d;
			if($id == $id_d){
				$flag=1;
				if(!$flag2){
					$flag2=1;
				}
				last;
			}
		}
		if(!$flag){
			$new[$idx++]=$ln;
		}
	}
	close FILE;
}


if(!$flag2){
	return;
}

unless(open(FILE,">$comlog")){
	&error("$comlogに書き込みできません。パーミッションを確認してください。");
}
print FILE @new;
close(FILE);


}

#?en bu
sub DelCategory{
my($ref,@keys,$l,$v,$id,@ok,$num,@un,@new,$file,$idx,$n,$c,$flag,$cateid,$m_d,$ref2,$hd);

$ref=$_[0];
@keys=keys %{$ref};

if(!$keys[0]){
	return;
}

unless(open(FILE,"$categorylog")){
	&error("categorylogが開けません。");
}
$hd=<FILE>;
@new=();
$flag=0;
$idx=0;
while(<FILE>){
	($cateid,$n,$c)=split(/,/,$_);
	if(@{${$ref}{$cateid}}){
		if(!$flag){
			$flag=1;
		}
		$num=$c;
		$c-=scalar(@{${$ref}{$cateid}});
		if($c < 0){
			$c=0;
		}
		if($c == 0){
			push @un,"$cateid,$num";
		}
		else{
			push @ok,$cateid;
		}
		$_="$cateid,$n,$c,\n";
	}
	$new[$idx++]=$_;

}
close FILE;

if($flag){
	unless(open(FILE,">$categorylog")){
		&error("categorylogに書き込みできません。パーミッション等を確認してください。");
	}
	print FILE $hd;
	print FILE @new;
	close FILE;

	foreach $l(@keys){
		@new=();
		$file=$catedir.$l.'.log';
		$flag=0;
		$ref2=&inhash2(\@{${$ref}{$l}});
		unless(open(FILE,$file)){
			&error("$fileが開けません。a8");
		}
		$idx=0;
		while(<FILE>){
			($m_d,$n)=split(/,/,$_);
			if(${$ref2}{$m_d}){
				$n-=${$ref2}{$m_d};
				if($n < 0){
					$n=0;
				}
				$_="$m_d,$n,\n";
			}
			$new[$idx++]=$_;
		}
		close FILE;
		unless(open(FILE,">$file")){
			&error("$fileに書き込みできません。$catedirのパーミッション等を確認してください。");
		}
		print FILE @new;
		close FILE;
	
	}

}

return(\@ok);

}


#----------------------------------

sub Env{
&checkpass($FORM{'pass'});
require $setpl;

&EnvForm;

}

sub EnvRegist{
&checkpass($FORM{'pass'});
require $setpl;
&EnvRegist;
&EnvForm;
}

sub PrintJsSet{

print <<'EOM';
<script type="text/javascript">
function Check(){
var err="";

if(document.fo.arpagemax.value == ""){
	err+="月別のページに表示する記事数が入力されていません。\n";
}
if(document.fo.pagemax.value == ""){
	err+="その他のページに表示する記事数が入力されていません。\n";
}
if(document.fo.entrytopmax.value == ""){
	err+="エントリーのリンクの数が入力されていません。\n";
}
if(document.fo.comtopmax.value == ""){
	err+="コメントのリンクの数が入力されていません。\n";
}
if(document.fo.artopmax.value == ""){
	err+="月別のリンクの数が入力されていません。\n";
}
if(document.fo.notitle.value == ""){
	err+="タイトルが未入力のときのタイトルが入力されていません。\n";
}
if(document.fo.top.value == ""){
	err+="ブログのトップページのファイル名が入力されていません。\n";
}
if(document.fo.entrydir.value == ""){
	err+="ブログのトップページのファイル名が入力されていません。\n";
}
if(document.fo.ardir.value == ""){
	err+="月別ページ生成ディレクトリが入力されていません。\n";
}
if(document.fo.upimgdir.value == ""){
	err+="画像をアップするディレクトリが入力されていません。\n";
}

if(document.fo.rss[1].checked == true){
	if(document.fo.rdf.value == ""){
		err+="RSSを生成するときはRSSファイルは入力必須です。\n";
	}
	if(document.fo.rsslink.value == ""){
		err+="RSSを生成するときはブログのURL(RSS用)は入力必須です。\n";
	}
	if(document.fo.kanri.value == ""){
		err+="RSSを生成するときは管理者は入力必須です。\n";
	}
}

if(document.fo.mail[1].checked == true || document.fo.mail[2].checked == true){
	if(document.fo.sendmail.value == ""){
		err+="レスの書き込みの際にメールで通知するときはsendmailは入力必須です。\n";
	}
	if(document.fo.mailto.value == ""){
		err+="レスの書き込みの際にメールで通知するときは管理人のメールアドレスは入力必須です。\n";
	}
}

if(err){
	alert(err);
	return false;
}
}
</script>
EOM

}


sub header{
my($h,$on,$imgdir_d,$upimgdir_d,$ltop);

$imgdir_d=$imgdir;
$upimgdir_d=$upimgdir;

if($baseurl){
	$imgdir_d=~s/^\.\.\///;
	$imgdir_d=~s/^\.\///;
	$imgdir_d=$baseurl.$imgdir_d;
	$upimgdir_d=~s/^\.\.\///;
	$upimgdir_d=~s/^\.\///;
	$upimgdir_d=$baseurl.$upimgdir_d;
}

if($tbuse){
	$ltop='580';
}
else{
	$ltop='540';
}

print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>管理画面</title>
<style type="text/css">
<!--

body{
font-family: "ＭＳ Ｐゴシック";
}


td,div{
font-size:10pt;
}
a{
color:#0A0FD8;
}

.tb{ 
border:1px solid #B4BACF;
border-collapse:collapse;
}
.tb td{ 
border:1px solid #B4BACF;
border-collapse:collapse;
}

.no_b{ 
border:none;
}
.no_b td{ 
border:none;
}


.bg{
background-color:#eeeeee;
}

.settbl{ 
border:1px solid #999999;
border-collapse:collapse;
background-color:#f9f9f9;
}
.settbl td{ 
border:1px solid #999999;
border-collapse:collapse;
}

.menutbl{
background-color:#fbfbfb;
border-color:#bbbbbb;
border-style:solid;
border-width:1px;
}

.komoku{
background-color:#e0e0e0;
}


#iconwin{
position:absolute;
top:153px;
left:400px;
border-style:solid;
border-width:1px;
width:155px;
height:auto;
border-color:#999999;
background-color:#ffffff;
}

#colorwin{
position:absolute;
top:153px;
left:440px;
border-style:solid;
border-width:1px;
width:160px;
height:auto;
border-color:#999999;
background-color:#ffffff;
}

#linkwin{
position:absolute;
top:${ltop}px;
left:182px;
border-style:solid;
border-width:1px;
width:560px;
height:auto;
border-color:#999999;
background-color:#ffffff;
padding:4px;
}

.noline{
border:none;
}
.noline td{
border:none;
}

.obi{
background-color:#999999;
}

-->
</style>
<script type="text/javascript">
var imgcount=0;
var imgarray=new Array();
var imgtagline=new Array();
var ctagline=new Array();
var allimg=new Array();
var win=null;
var iconarray=new Array();
var icontagline=new Array();

var oimgarray=new Array();
var oimgtagline=new Array();
var octagline=new Array();
var imgdir='$imgdir_d';
var tmpimgdir='$tmpimgdir';
var upimgdir="$upimgdir_d";
var m='$_[2]';
var cate='$_[3]';
var pass='$FORM{'pass'}';
var su='$su';
var w_max='$w_max';
</script>
<script type="text/javascript" src="all.js">
</script>
EOM

if($_[0] eq 'set'){
	&PrintJsSet;
}
elsif($_[0] eq 'entryeditregist'){
	$on=" onload=\"ShowImg();\"";
}



print "</head>\n";
print "<body$on>\n";


}


sub error{

if($lock && $lockflag==1){
	close LOCK;
}

&header;

print <<EOM;
<div align="center">ERROR<br><br>
EOM

print"$_[0]\n";

print <<EOM;
</div>
</body>
</html>
EOM
exit;

}

exit;