
sub Cut2{
my($ref,$head,$dummy,$table,$footer);

$ref=$_[0];

($head,$dummy) = split(/<!--start-->/, ${$ref});
if($head eq ""){
	&error("スキンに&lt;!--start--&gt;が書かれていません。");
}
($table,$footer) = split(/<!--end-->/, $dummy);
if($table eq ""){
	&error("スキンに&lt;!--end--&gt;が書かれていません。");
}

return($head,$table,$footer);

}

sub GetCom{
my($m,$no,@com,$file,$hd,$idx,$cno,$no_d);

$m=$_[0];
$no=$_[1];
@com=();

$file="$comdir$m.log";

if(!-e $file){
	return(\@com);
}

unless(open(COM,$file)){
	&error("$fileが開けません。");
}
$hd=<COM>;
$idx=0;
while(<COM>){
	($cno,$no_d)=split(/,/,$_);
	if($no_d == $no){
		$com[$idx]=$_;
		$idx++;
	}

}
close COM;

return(\@com);

}

sub GetTb{
my($m,$no,@tb,$file,$hd,$idx,$tno,$no_d);

$m=$_[0];
$no=$_[1];

@tb=();
$file="$tbdir$m.log";

if(!-e $file){
	return(\@tb);
}

unless(open(TB,$file)){
	&error("$fileが開けません。");
}
$hd=<TB>;
$idx=0;
while(<TB>){
	($tno,$no_d)=split(/,/,$_);
	if($no_d == $no){
		$tb[$idx++]=$_;
	}

}
close TB;

return(\@tb);

}

sub GetMonth{
my($m,$num,$flag,$i,$m_d,$backmon,$n,$nextmon,$line);

$m=$_[0];
$num=0;
if(!open(ALOG,$arlog)){
	&error("arlogが開けません。m13");
}
$flag=0;
while(<ALOG>){
	$i++;
	($m_d,$n)=split(/,/,$_);
	if($m_d == $m){
		$flag=1;
		if(!eof){
			$line=<ALOG>;
			($backmon,$n)=split(/,/,$line);
		}
		last;
	}
	$nextmon=$m_d;
}
close ALOG;

if(!$flag){
	$nextmon="";
}

return($backmon,$nextmon);
}
sub BackRead{
my($bufsize,$size,$pos,$buf_tmp,@lines,$n,$num,$j,$eflag,@all,$i,$fh,$buf,$line);

$bufsize=1024;
$fh=$_[0];
binmode($fh);

$size=(-s $fh)/$bufsize;
$pos += $size <=> ($pos = int($size));
$eflag=0;
$num=$pos;
$i=0;

while($pos--) {
	$j++;
	seek($fh,$bufsize*$pos,0);
	read($fh,$buf,$bufsize);
	$buf.=$buf_tmp;
	($buf_tmp,@lines)=$buf=~/[^\x0D\x0A]*\x0D?\x0A?/g;
	pop(@lines);
	if(@lines){
		$line=$lines[$#lines];
		$line.="\n" if $line !~ /[\x0D\x0A]$/;
		last;
	}

}

return($line);
}


sub GetSize{
my($fi,$ex,$w,$h,$size,$i,$mark,$code,$len);

$ex=$_[0];
$fi=$_[1];
$w=0;
$h=0;
if($ex eq "gif" || $ex eq "GIF"){
	unless(open(GIF,$fi)){
		return(0,0);
	}
	seek(GIF,6,0);
	if(read(GIF,$size,4)){
		($w,$h)=unpack("vv",$size);
	}
	close(GIF);
	return($w,$h);
}
elsif($ex eq "jpg" || $ex eq "JPG"){
	unless(open(JPEG,$fi)){
		return(0,0);
	}
	binmode JPEG;
	read(JPEG,$b,2);
	for($i=0;$i<10;$i++) {
		unless(read(JPEG,$b,4)){
			last;
		}
		($mark,$code,$len)=unpack("CCn",$b);
		if($mark != 0xFF){
			last;
		}
		elsif($code == 0xC0) {
      			if(read(JPEG,$b,5)){
     				($h,$w)=unpack("xnn",$b);
			}
     			last;
        	}
		else{
 			unless(read(JPEG,$b,($len-2))){
				last;
			}
		}

	}
    	close JPEG;
	return($w,$h);
}

}

sub GetHost{
my($host);
$host=$ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'};
return $host;
}


sub GetTimeFull{
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$mon++;
$year=$year+1900;
$mon=sprintf("%02d",$mon);
$mday=sprintf("%02d",$mday);
$hour=sprintf("%02d",$hour);
$min=sprintf("%02d",$min);
return($year,$mon,$mday,$hour,$min,$wday);
} 


sub GetDate{
my ($date,@week,$y,$m,$mday,$wday,$hour,$min);
$y=$_[0];
$m=$_[1];
$mday=$_[2];
$wday=$_[3];
$hour=$_[4];
$min=$_[5];
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date="$y/$m/$mday $hour:$min";
return $date;
}

sub GetTime{
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$mon++;
$year=$year+1900;
$mon=sprintf("%02d",$mon);
return($year,$mon);
}

sub GetEntryFile{
my($no,$yr,$mn,$entry_html);

$no=$_[0];
$yr=$_[1];
$mn=$_[2];

if($su){
	$entry_html=$entrydir.$yr."/".$mn."/".$no.$htmlext;
}
else{
	$entry_html=$entrydir."/".$yr.$mn.$no.$htmlext;
}

return $entry_html;
}


sub GetCount{
my($act,$dum,$ecnt,$ccnt,$tcnt,$cnt);

$act=$_[0];

unless(open(FILE,$countlog)){
	&error("countlogが開けません。");
}
$dum=<FILE>;
close FILE;
($ecnt,$ccnt,$tcnt)=split(/,/,$dum);
if($act eq "entry"){
	$cnt=$ecnt;
}
elsif($act eq "com"){
	$cnt=$ccnt;
}
elsif($act eq "tb"){
	$cnt=$tcnt;
}
return $cnt;
}

sub MakeIcon{
my($icontable,$imgdir_d,$k,$j,$col,$img,$w,$h,$n,$sa,$i);

$imgdir_d=$imgdir;
$imgdir_d=~s/^\.\.\///;
$imgdir_d=~s/^\.\///;

if($baseurl){
	$imgdir_d=$baseurl.$imgdir_d;
}
else{
	if($entrymode){
		if($su){
			$imgdir_d="../../../".$imgdir_d;
		}
		else{
			$imgdir_d="../".$imgdir_d;
		}
	}
	else{
		$imgdir_d="../".$imgdir_d;
	}
}

$icontable="<div style=\"text-align:right;font-size:11px;margin:2px 2px 0px 0px;width:100%;\"><a href=\"javascript:void(0)\" onclick=\"IconClose();\">×</a></div>\n";
$icontable.="<table class=\"no_b\">\n";

$k=0;
$j=0;
$col=9;
foreach(@ICON){
	$img=${$_}[0];
	$w=${$_}[1];
	$h=${$_}[2];
	$n=${$_}[3];
	$j++;
	$k++;
	if($j==1){
		$icontable.="<tr>\n";
	}
	$icontable.="<td>\n";
	$icontable.="<a href=\"javascript:void(0)\" onclick=\"PutIcon('$img','$w','$h','$n')\"><img src=\"$imgdir_d$img\" width=\"$w\" height=\"$h\" border=\"0\"></a>";
	$icontable.="</td>\n";
	if($j==$col){
		$icontable.="</tr>\n";
		$j=0;
	}
}
if($j && ($j != $col)){
	$sa=$col-$j;
	for($i=0;$i<$sa;$i++){
		$icontable.="<td></td>\n";
	}
	$icontable.="</tr>\n";
}
$icontable.="</table>\n";

return(\$icontable);

}

sub GetFN{
my($m,$no_d,$file,$flag,$i,$no,$entryline,$former,$former_m,$next,$next_m,
$idx,$mm,@files,$jj,$q,$f,$hd,$enum,$n_fname,$fh,$f_fname,$j
);

$m=$_[0];
$no_d=$_[1];

$file=$logdir.$m.'.log';

unless(open(FN,$file)){
	&error("$fileが開けません。m1");
}

$hd=<FN>;
($enum)=split(/,/,$hd);
$flag=0;
$i=0;
while(<FN>){
	$i++;
	($no)=split(/,/,$_);
	if($no == $no_d){
		$entryline=$_;
		$flag=1;
		if(!eof){
			$former=<FN>;
			$former_m=$m;
		}
		last;
	}
	$next=$_;
	$next_m=$m;
}
close FN;

if(!$flag){
	$next="";
	$next_m="";
}

if($i == 1 || $i == $enum){
	if(!open(ALOG,$arlog)){
		&error("arlogが開けません。m2");
	}
	$j=0;
	$flag=0;
	$idx=0;
	while(<ALOG>){
		($mm)=split(/,/,$_);
		$files[$idx++]=$mm;
		if($flag){
			last;
		}
		if($mm == $m){
			$jj=$j;
			$flag=1;
		}
		$j++;
	}
	close ALOG;

	if($i == 1){
		$j=$jj-1;
		for($q = $j;$q >= 0;$q--){
			$f=$files[$q];
			$file=$f.'.log';
			if(-e "$logdir$file"){
				unless(open(FN,"$logdir$file")){
					&error("$logdir$fileが開けません。m3");
				}
				$hd=<FN>;
				($enum)=split(/,/,$hd);
				if(!$enum){
					close FN;
					next;
				}
				else{
					$n_fname=$file;
					$next=<FN>;
					$next_m=$f;
					close FN;
					last;
				}
			}
		}
	}

	if($i == $enum){
		$j=$jj+1;
		for($q = $j;$q < scalar(@files);$q++){
			$f=$files[$q];
			$file=$f.'.log';
			if(-e "$logdir$file"){
				unless(open(FN,"$logdir$file")){
					&error("$logdir$fileが開けません。m4");
				}
				$hd=<FN>;
				$fh=*FN;
				($enum)=split(/,/,$hd);
				if(!$enum){
					close FN;
					next;
				}
				else{
					$f_fname=$file;
					$former=&BackRead($fh);
					$former_m=$f;
					close FN;
					last;
				}
			}
		}
	}

}

return($former,$former_m,$next,$next_m,$entryline);

}

sub GetMFN{
my($m_t,$m,$n,$next_m,$former_m,$dum);

$m_t=$_[0];


unless(open(FILE,$arlog)){
	&error("$arlogが開けません。");
}
while(<FILE>){
	($m,$n)=split(/,/,$_);
	if($m == $m_t){
		if(!eof){
			$dum=<FILE>;
			($m,$n)=split(/,/,$dum);
			$former_m=$m;
		}
		last;
	}
	$next_m=$m;
}
close FILE;

return($former_m,$next_m);


}

sub EmptyCheck{
my($dir,@files);
$dir=$_[0];

if(!-e $dir){
	return;
}

unless(opendir(DIR,$dir)){
	&error("$dirが開けません。a1");
}
@files=readdir DIR;
closedir DIR;
if(scalar(@files) == 2){
	rmdir $dir || &error("$dirが削除できません。");
}

}

sub GetImgPath{
my($y,$m,$updir);
$y=$_[0];
$m=$_[1];

if($su){
	$updir=$upimgdir.$y.'/'.$m.'/';
}
else{
	$updir=$upimgdir;
}

return $updir;

}

sub filelock{
my($result,$i);
$lockflag = 0;
if(open(LOCK, ">$lockfile")){
	eval{$result=flock(LOCK,2);};
	if($@){&error("このサーバーはflockが使えないので、ロックはオフにしてください。");}
	if($result){
		$lockflag=1;
	}
	else{
		$lockflag=2;
		close LOCK;
	}
	$result=0;
}
else{
	&error("lockファイルがないか、パーミッションが書き込み可になっていません。");
}
if($lockflag == 2){
	&error("書き込みできませんでした。もう一度お試しください。");
}
}

sub encode{
my(@saltset,$salt,$newcode);
@saltset=('a'..'z','A'..'Z','0'..'9');
srand(time^$$);
$salt=$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))];
eval{$newcode=crypt($_[0],$salt);};
if($@){
	&error("暗号化の関数がサポートされていないのでこのサーバーでは使えません。");
}
if($newcode=~/^\$1\$/){
	$newcode=crypt($_[0],'$1$');
}
return $newcode;
}


sub MatchPass{
my($pass,$coded,$salt,$passflag);
$pass=$_[0];
$coded=$_[1];
$passflag=0;
if($coded=~/^\$1\$/){
	if(crypt($pass,'$1$') eq $coded){
		$passflag=1;
	}
}
else{
	$salt=substr($coded,0,2);
	if(crypt($pass,$salt) eq $coded){
		$passflag=1;
	}
}
return $passflag;
}

sub SuCheck{
my(@ptmp,$fn,$eid,$flag,$oid);

@ptmp=split(/\//,$ENV{'SCRIPT_FILENAME'});
$fn=$ptmp[$#ptmp];
$oid=(stat($fn))[4];
$eid = $<;
if($eid eq $oid){
	$flag=1;
}
else{
	$flag=0;
}
return $flag;
}

sub MakeImgDir{
my($yr,$mn,$dir1,$dir2);

$yr=$_[0];
$mn=$_[1];
$dir1=$upimgdir.$yr;
$dir2=$upimgdir.$yr.'/'.$mn.'/';
if(!-e $dir1){
	if(!mkdir($dir1)){
		&error("$dir1が作れません。$upimgdirのパーミッション等を確認してください。");
	}
}
if(!-e $dir2){
	if(!mkdir($dir2)){
		&error("$dir2が作れません。$upimgdirのパーミッション等を確認してください。");
	}
}

}

sub TagCheck{
my $ref=$_[0];
foreach(@avoid){
	if(${$ref}=~/$_/i){
		&Alert("禁止タグが含まれています。");
	}
}
}

sub Alert{
my($msg,$on);
$msg=$_[0];

$on=" onload=\"Alert('$msg')\"";
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Content-Style-Type" content="text/css">
<title></title>
<script type="text/javascript">
<!--
function Alert(m){
alert(m);
}
//-->
</script>
</head>
<body$on>
</body>
</html>
EOM

exit;

}


1;
