#!/usr/bin/perl

#--------ライブラリ読込み------------------------

if(!-e 'lib/conf.pl'){
	&error("conf.plがありません。");
}
require 'lib/conf.pl';

if(!-e 'lib/conf2.cgi'){
	&error("conf2.cgiがありません。");
}
require 'lib/conf2.cgi';

if(!-e 'lib/functions.pl'){
	&error("functions.plがありません。");
}
require 'lib/functions.pl';

if(!-e 'lib/makecgi.pl'){
	&error("functions.plがありません。");
}
require 'lib/makecgi.pl';

#-------変数-------------------------------------

$script="search.cgi";
$intvl=2;	#検索をリロードする間隔(秒)
$readnum=2;

#------------------------------------------------

if(!&SuCheck){
	$su=0;
}

%table=(
'Ａ'=>'a',
'Ｂ'=>'b',
'Ｃ'=>'c',
'Ｄ'=>'d',
'Ｅ'=>'e',
'Ｆ'=>'f',
'Ｇ'=>'g',
'Ｈ'=>'h',
'Ｉ'=>'i',
'Ｊ'=>'j',
'Ｋ'=>'k',
'Ｌ'=>'l',
'Ｍ'=>'m',
'Ｎ'=>'n',
'Ｏ'=>'o',
'Ｐ'=>'p',
'Ｑ'=>'q',
'Ｒ'=>'r',
'Ｓ'=>'s',
'Ｔ'=>'t',
'Ｕ'=>'u',
'Ｖ'=>'v',
'Ｗ'=>'w',
'Ｘ'=>'x',
'Ｙ'=>'y',
'Ｚ'=>'z',

'ａ'=>'a',
'ｂ'=>'b',
'ｃ'=>'c',
'ｄ'=>'d',
'ｅ'=>'e',
'ｆ'=>'f',
'ｇ'=>'g',
'ｈ'=>'h',
'ｉ'=>'i',
'ｊ'=>'j',
'ｋ'=>'k',
'ｌ'=>'l',
'ｍ'=>'m',
'ｎ'=>'n',
'ｏ'=>'o',
'ｐ'=>'p',
'ｑ'=>'q',
'ｒ'=>'r',
'ｓ'=>'s',
'ｔ'=>'t',
'ｕ'=>'u',
'ｖ'=>'v',
'ｗ'=>'w',
'ｘ'=>'x',
'ｙ'=>'y',
'ｚ'=>'z',

'０'=>'0',
'１'=>'1',
'２'=>'2',
'３'=>'3',
'４'=>'4',
'５'=>'5',
'６'=>'6',
'７'=>'7',
'８'=>'8',
'９'=>'9',

'A'=>'a',
'B'=>'b',
'C'=>'c',
'D'=>'d',
'E'=>'e',
'F'=>'f',
'G'=>'g',
'H'=>'h',
'I'=>'i',
'J'=>'j',
'K'=>'k',
'L'=>'l',
'M'=>'m',
'N'=>'n',
'O'=>'o',
'P'=>'p',
'Q'=>'q',
'R'=>'r',
'S'=>'s',
'T'=>'t',
'U'=>'u',
'V'=>'v',
'W'=>'w',
'X'=>'x',
'Y'=>'y',
'Z'=>'z',
);

$maxsize=100000;

require 'lib/conf.pl';

$FORM{'page'}=0;

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>$maxsize){&error("投稿量が多すぎます。");}
		read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
	}
else{
	$buff=$ENV{'QUERY_STRING'};
}
if($buff){
	&decode;
}

sub decode{
my(@pairs,$pair,$value,$name);
@pairs=split(/&/,$buff);
foreach $pair (@pairs){
	($name,$value)=split(/=/,$pair);
	$value=~tr/+/ /;
	$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
	$value=~s/&//g;
	$value=~s/<//g;
	$value=~s/>//g;
	$value=~s/"//g;
	$value=~s/'//g;
	$value=~s/\x0D\x0A//g;
	$value=~s/\x0D//g;
	$value=~s/\x0A//g;
	$FORM{$name}=$value;
}
}

if($FORM{'mode'} eq "search"){
	&SearchReady;
}
elsif($FORM{'mode'} eq "view"){
	&View;
}
elsif($FORM{'mode'} eq "dosearch"){
	&DoSearch;
}
elsif($FORM{'mode'} eq "allsearch"){
	&SearchReady('all');
}
else{
	&error("");
}


sub SearchReady{
my($max);
$max=0;
if(!open(ALOG,$arlog)){
	&error("$arlogが開けません。");
}
while(<ALOG>){
	$max++;
}
close ALOG;

if($_[0] eq 'all'){
	$FORM{'max'}=$max;
	$FORM{'hit'}=0;
	$FORM{'done'}=0;
	&DoSearch('all');
}
else{
	&Search($max,0,0,0,"","");
}
}


sub Search{
my($max,$done,$hit,$endflag,$fmon,$lmon,$timer,$left,$time,$unit,$line);
$max=$_[0];
$done=$_[1];
$hit=$_[2];
$endflag=$_[3];
$fmon=$_[4];
$lmon=$_[5];

$timer=$intvl*1000;


$left=$max-$done;
$time=$left*$intvl;
if($time >= 60){
	$time=int($time/60);
	$unit='分';
}
else{
	$unit='秒';
}

if($max){
	if(!$endflag){
		if($done){
			$line="0_$FORM{'sline'}_${hit}_${done}_${max}_";
			$line.="全ログ$max中$doneファイル検索しました。<br>";
			$line.="[$fmon-$lmon]<br>";

			$line.="$hit件ヒットしました。<br>";
			$line.="残り$leftファイル<br>";
			$line.="残り時間約$time$unit<br>";
			$line.="<br>";
			$line.="[<a href=\"javascript:void()\" onclick=\"Stop()\">中止する</a>]";
			$line.="[<a href=\"javascript:void()\" onclick=\"View()\">中止して検索結果を見る</a>]";
		}
		else{
			$FORM{'max'}=$max;
			$FORM{'hit'}=0;
			$FORM{'done'}=0;
			&DoSearch;
		}
	}
	else{
		$line="2_$FORM{'sline'}_${hit}_${done}_${max}_検索完了しました。\n";
	}
}
else{
	$line="1____データがありません。\n";
}

print "Content-type: text/plain\n\n";
print $line;
exit;



}

sub Han{
my $s=$_[0];

$s=~s/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xC0-\xDF][\x80-\xBF]|[\x21-\x7E])/defined($table{$1})? $table{$1} : $1/ge;

return $s;
}


sub DoSearch{
my($done,$hit,$keyword,@word,$max,$end,
$i,$sline,$fflag,$m,$first,@new,$idx,$f,$hd,
$no,$day,$tm,$category,$comcount,$tbcount,$name,$title,$email,$message,
$tmp,$flag,$w,$result,$line,$last,$f_y,$f_m,$l_y,$l_m,$fmon,$lmon,$start,$endflag
);
if($FORM{'keyword'} eq ""){
	&error("検索語が入力されていません。");
}

$done=$FORM{'done'};
$hit=$FORM{'hit'};
$keyword=$FORM{'keyword'};

$keyword=~s/　/ /g;
$keyword=&Han($keyword);
@word=split(/ /,$keyword);

$max=$FORM{'max'};

$start=$FORM{'done'}+1;


if($_[0] eq 'all'){
	$end=$max;
}
else{
	$end=$start+$readnum-1;
}

if($end > $max){
	$end=$max;
}

$i=0;
$sline="";
if(!open(ALOG,$arlog)){
	&error("$arlogが開けません。");
}
$fflag=0;
while(<ALOG>){
	($m)=split(/,/,$_);
	$i++;
	if($i > $end){
		last;
	}
	if($i < $start){
		next;
	}
	$done++;
	if(!$fflag){
		$first=$m;
		$fflag=1;
	}
	@new=();
	$idx=0;
	$f=$logdir.$m.'.log';
	unless(open(FILE,$f)){
		&error("$fが開けません。");
	}
	$hd=<FILE>;

	while(<FILE>){
		($no,$day,$tm,$category,$comcount,$tbcount,$name,$title,$email,$message)=split(/,/,$_);
		$tmp=$name.$title.$message;
		$tmp=&Han($tmp);
		$flag=0;
		foreach $w(@word){
			$result=0;
			$result=index($tmp,$w);
			if($result < 0){
				$flag=1;
				last;
			}
		}
		if(!$flag){
			$new[$idx++]=$no;
			$hit++;
		}
	}
	close FILE;
	if(scalar(@new)){
		$line.=$m."#".join(":",@new)."/";
	}
	$last=$m;


}
close ALOG;

if($done >= $max){
	$endflag=1;
}

$FORM{'sline'}.=$line;

$f_y=substr($first,0,4);
$f_m=substr($first,4,2);
$l_y=substr($last,0,4);
$l_m=substr($last,4,2);
$fmon="$f_y年$f_m月";
$lmon="$l_y年$l_m月";

if($_[0] eq 'all'){
	$FORM{'hit'}=$hit;
	&View;
}
else{
	&Search($max,$done,$hit,$endflag,$fmon,$lmon);
}

}



sub View{
my($skinline,$head,$table,$footer,$allcount,$oya,@line,$start,$end,$result,
$allnum,$pageflag,$eflag,$i,$v,$m,$k,$f,@kiji,$cnt,$yr,$mn,$hd,$j,$flag,$id,$n,$page_next,
$page_back,$bt,
);


unless(open(HTML, "$topskin")){
	&error("$topskinが開けません。ファイルを確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);

$skinline=~s/<!--formstart-->.*?<!--formend-->//s;
$skinline=~s/<!--navi-->.*?<!--\/navi-->/<!--result--><br><br>/s;
$skinline=~s/<!--tb-->.*?<!--\/tb-->//s;


&Tag("cgi",\$skinline);

($head,$table,$footer)=&Cut2(\$skinline);

$allcount=$FORM{'hit'};
$oya=$allcount;
@line=split(/\//,$FORM{'sline'});

$start=$FORM{'page'}+1;
$end=$FORM{'page'}+$pagemax;

$result="検索結果: $allcount件";

$head=~s/<!--result-->/$result/;


print "Content-type: text/html\n\n";

print $head;

$allnum=0;
$pageflag=0;
$eflag=0;
$i=0;

foreach $v(@line){
	($m,$k)=split(/#/,$v);
	$f=$m.'.log';
	@kiji=split(/:/,$k);
	$cnt=scalar(@kiji);
	if(!$pageflag){
		$allnum+=$cnt;
		if($allnum >= $start){
			$pageflag=1;
			$i=$allnum-$cnt;
		}
	}
	if(!$pageflag){
		next;
	}

	$yr=substr($m,0,4);
	$mn=substr($m,4,2);
	unless(open(FILE,"$logdir$f")){
		&error("$logdir$fが開けません。");
	}
	$hd=<FILE>;
	$j=0;
	while(<FILE>){
		$flag=0;
		($id)=split(/,/,$_);
		foreach $n(@kiji){
			if($n == $id){
				$flag=1;
				last;
			}
		}
		if($flag){
			$i++;
			$j++;
		}
		else{
			next;
		}
		if($i > $end){
			$eflag=1;
			last;
		}
		if($i < $start){
			next;
		}
		&MOutput("s",\$_,\$table,"",$m);
		if($i == $end){
			$eflag=1;
			last;
		}
		if($i >= $allcount){
			$eflag=1;
			last;
		}
		if($j == $cnt){
			last;
		}
	}
	close FILE;
	if($eflag){
		last;
	}

}



$page_next=$FORM{'page'}+$pagemax;
$page_back=$FORM{'page'}-$pagemax;

if($page_next<$oya){
	$bt="<form action=\"$script\" method=\"POST\">\n";
	$bt.="<input type=\"hidden\" name=\"mode\" value=\"view\">\n";
	$bt.="<input type=\"hidden\" name=\"hit\" value=\"$FORM{'hit'}\">\n";
	$bt.="<input type=\"hidden\" name=\"sline\" value=\"$FORM{'sline'}\">\n";
	$bt.="<input type=\"hidden\" name=\"page\" value=\"$page_next\">\n";
	$bt.="<input type=\"submit\" value=\"次の$pagemax件\">\n";
	$bt.="</form>\n";
}
if($page_back>=0){
	$bt="<form action=\"$script\" method=\"POST\">\n";
	$bt.="<input type=\"hidden\" name=\"mode\" value=\"view\">\n";
	$bt.="<input type=\"hidden\" name=\"hit\" value=\"$FORM{'hit'}\">\n";
	$bt.="<input type=\"hidden\" name=\"sline\" value=\"$FORM{'sline'}\">\n";
	$bt.="<input type=\"hidden\" name=\"page\" value=\"$page_back\">\n";
	$bt.="<input type=\"submit\" value=\"前の$pagemax件\">\n";
	$bt.="</form>\n";
}

$footer=~s/<!--page-->/$bt/;
print $footer;
exit;


}


sub header{

print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<STYLE TYPE="text/css">
<!--
div,td{font-size:10pt}
-->
</STYLE>
</head>
<body>
EOM

}

sub error{

&header;

print <<EOM;
<br>
<br>
<div align="center">ERROR<br><br>
EOM

print"$_[0]\n";

print <<EOM;
</div>
</body>
</html>
EOM
exit;

}



exit;