#!/usr/bin/perl

use CGI qw/:standard/;
use Jcode;

#--------ライブラリ読込み------------------------

if(!-e 'lib/conf.pl'){
	&error("conf.plがありません。");
}
require 'lib/conf.pl';

if(!-e 'lib/conf2.cgi'){
	&error("conf2.cgiがありません。");
}
require 'lib/conf2.cgi';

if(!-e 'lib/functions.pl'){
	&error("functions.plがありません。");
}
require 'lib/functions.pl';

if(!-e 'lib/makepage.pl'){
	&error('makepage.plがありません。');
}
require 'lib/makepage.pl';

#------------------------------------------------

if(!&SuCheck){
	$su=0;
}

&tbregist;

sub tbregist{
my(
$q,$foo,$url,
$ping_url,$excerpt,$blog_name,$path,
@dum,$no,$len,
$fileno,$id,$file,$flag,
$id_d,$day,$category,$count,$tbcount,$name,$title,$email,$date,$time,$message,$img,$img2,$tb,$comment,
$tbline,@tb,$entryline,@new,$entry_html,
$hd,$enum,$cnum,$tnum,
);


&filelock;

$q = new CGI;
$foo = $q->Vars;

$url = $q->param('url');
$title = $q->param('title');
$ping_url = $q->param('ping_url'); 
$excerpt = $q->param('excerpt'); 
$blog_name = $q->param('blog_name');
$path=$q->path_info();

$url=~s/\n//g;
$title=~s/\n//g;
$ping_url=~s/\n//g;
$excerpt=~s/\n/<br>/g;
$blog_name=~s/\n//g;

Jcode::convert(\$title,'utf8');
Jcode::convert(\$except,'utf8');
Jcode::convert(\$blog_name,'utf8');

@dum=split(/\//,$path);
$id=$dum[$#dum];

if($id eq ""){
	&SendResponse("1","no ID");
}
if($url eq ""){
	&SendResponse("1","no url");
}

$len=length $id;

$m=substr($id,0,6);
$no=substr($id,6,$len-6);

$host=&GetHost;

@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

($year,$mon,$mday,$hour,$min,$wday)=&GetTimeFull;
$date="$year/$mon/$mday $hour:$min";

$tbfile="$tbdir$m.log";

if(!-e $tbfile){
	unless(open(FILE,">$tbfile")){
		&error("$tbfileに書き込めません。$tbdirのパーミッション等を確認してください。");
	}
	close FILE;
}

unless(open(FILE,$tbfile)){
	&error("$tbfileが開けません。");
}
$hd=<FILE>;
($tno)=split(/,/,$hd);
if($tno eq ""){
	$tno=0;
}
$tno++;

$tmp="$tno,$no,$id,$title,$excerpt,$url,$blog_name,$date,$host,\n";

$idx=0;
$flag=0;
$flag2=0;
@tb=();
$tidx=0;
while(<FILE>){
	($num,$no_d)=split(/,/,$_);
	if($flag){
		$tb[$tidx]=$_;
		$tidx++;
	}
	if($flag && $no_d != $no){
		$new[$idx]=$tmp;
		$idx++;
		$flag2=1;
		$flag=0;
		$tb[$tidx]=$tmp;
		$tidx++;
	}
	if(!$flag && !$flag2 && $no_d == $no){
		$flag=1;
		$tb[$tidx]=$_;
		$tidx++;
	}
	$new[$idx]=$_;
	$idx++;
}

close FILE;

if(!$flag2){
	$new[$idx]=$tmp;
	$tb[$tidx]=$tmp;
}

$hd="$tno,\n";

unless(open(FILE,">$tbfile")){
	&error("$tbfileに書き込めません。$tbdirのパーミッション等を確認してください。");
}
print FILE $hd;
print FILE @new;
close FILE;


$file=$logdir.$m.'.log';

if(!-e $file){
	&SendResponse("1","no data");
}


unless(open(FILE,$file)){
	&error("$fileが開けません。");
}
$hd=<FILE>;
$idx=0;
@new=();
$flag=0;
while(<FILE>){
	($no_d,$day,$t,$category,$comcount,$tbcount,$name,$title,$email,$message,$img)=split(/,/,$_);
	if($no_d == $no){
		$tbcount++;
		$_="$no_d,$day,$t,$category,$comcount,$tbcount,$name,$title,$email,$message,$img,\n";
		$entryline=$_;
		$flag=1;
	}
	$new[$idx++]=$_;
}
close FILE;

if(!$flag){
	&SendResponse("1","no data");
}

($enum,$eno,$cnum,$tnum,$mline)=split(/,/,$hd);
$tnum++;
$hd="$enum,$eno,$cnum,$tnum,$mline,\n";

unless(open(FILE,">$file")){
	&error("$fileに書き込めません。$logdirのパーミッション等を確認してください。");
}
print FILE $hd;
print FILE @new;
close FILE;

unless(open(FILE,$countlog)){
	&error("$countlogが開けません。");
}
$dum=<FILE>;
close FILE;
($ecnt,$ccnt,$tcnt)=split(/,/,$dum);

$tcnt++;
unless(open(FILE,">$countlog")){
	&error("$countlogに書き込めません。パーミッション等を確認してください。");
}
print FILE "$ecnt,$ccnt,$tcnt,\n";
close FILE;


if($entrymode){
	$yr=substr($m,0,4);
	$mn=substr($m,4,2);
	$ref=&GetCom($m,$no);
	$entry_html=&GetEntryFile($no,$yr,$mn);
	&MakeEntryHtml("",$entry_html,$entryline,$yr,$mn,$ref,\@tb);
}

&MakeTop("renew");

&SendResponse("0","Thanks for your Ping to $id");

if($lockflag==1){
	close LOCK;
}

}

sub filelock{
my($result,$i);
$lockflag = 0;
if(open(LOCK, ">$lockfile")){
	eval{$result=flock(LOCK,2);};
	if($@){&error("このサーバーはflockが使えないので、ロックはオフにしてください。");}
	if($result){
		$lockflag=1;
	}
	else{
		$lockflag=2;
		close LOCK;
	}
	$result=0;
}
else{
	&error("lockファイルがないか、パーミッションが書き込み可になっていません。");
}
if($lockflag == 2){
	&error("書き込みできませんでした。もう一度お試しください。");
}
}



sub SendResponse{

my($error,$msg);

if($lock && $lockflag==1){
	close LOCK;
}

$error=$_[0];
$msg=$_[1];

print "Content-type: text/xml\n\n";
print <<EOM;
<?xml encoding="utf-8"?>
<response>
<error>$error</error>
<message>$msg</message>
</response>
EOM
exit;
}



exit;