#!/usr/bin/perl

#--------ライブラリ読込み------------------------

if(!-e 'lib/conf.pl'){
	&error("conf.plがありません。");
}
require 'lib/conf.pl';

if(!-e 'lib/conf2.cgi'){
	&error("conf2.cgiがありません。");
}
require 'lib/conf2.cgi';

if(!-e 'lib/functions.pl'){
	&error("functions.plがありません。");
}
require 'lib/functions.pl';


#-------変数-------------------------------------

$script="keitai.cgi";
$keitai_top='../skin/keitai_top.html';
$keitai_entry='../skin/keitai_entry.html';
$keitai_ar='../skin/keitai_archive.html';
$keitai_cate='../skin/keitai_cate.html';
$keitai_tb='../skin/keitai_tb.html';
$keitai_com='../skin/keitai_com.html';
$keitai_thanks='../skin/keitai_thanks.html';

$l_color="#0000ff";	#リンク色
$t_color="#000000";	#文字色
$b_color="#ffffff";	#背景色

$k_entopmax=10;
$k_artopmax=10;
$k_catetopmax=10;

$ansdigit=4;
#----------------------------------------------

if(!&SuCheck){
	$su=0;
}

$maxsize=100000;


$FORM{'page'}=0;

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>$maxsize){&error("投稿量が多すぎます。");}
		read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
	}
else{
	$buff=$ENV{'QUERY_STRING'};
}
if($buff){
	&decode;
}

sub decode{
my(@pairs,$pair,$value,$name);
@pairs=split(/&/,$buff);
foreach $pair (@pairs){
	($name,$value)=split(/=/,$pair);
	$value=~tr/+/ /;
	$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
	if($value eq "on"){
		$value="";
	}
	$value=~s/&/&amp;/g;
	$value=~s/</&lt;/g;
	$value=~s/>/&gt;/g;
	$value=~s/"/&quot;/g;
	$value=~s/'/&#039;/g;
	if($name eq "message"){
		$value=~s/\x0D\x0A/<br>/g;
		$value=~s/\x0D/<br>/g;
		$value=~s/\x0A/<br>/g;
	}
	else{
		$value=~s/\x0D\x0A//g;
		$value=~s/\x0D//g;
		$value=~s/\x0A//g;
	}

	$FORM{$name}=$value;
}
}

$FORM{'act'}='keitai';

if($FORM{'mode'} eq "entry"){
	&Entry;
}
elsif($FORM{'mode'} eq "comment"){
	&Comment;
}
elsif($FORM{'mode'} eq "category"){
	&Category;
}
elsif($FORM{'mode'} eq "archive"){
	&Archive;
}
elsif($FORM{'mode'} eq "tb"){
	&Tb;
}
elsif($FORM{'mode'} eq "regist"){
	if($cap){
		&Ninsho;
	}
	if(!-e 'lib/res.pl'){
		&error("res.plがありません。");
	}
	require 'lib/res.pl';
	if($rescheck){
		&TmpRegist;
	}
	else{
		if(!-e 'lib/makepage.pl'){
			&error('makepage.plがありません。');
		}
		require 'lib/makepage.pl';
		$FORM{'tmpmsg'}=$FORM{'message'};
		&Regist;
	}
}
if($FORM{'mode'} eq "delform"){
	&DelForm;
}
if($FORM{'mode'} eq "usrdel"){
	if(!-e 'lib/res.pl'){
		&error("res.plがありません。");
	}
	require 'lib/res.pl';
	if(!-e 'lib/makepage.pl'){
		&error('makepage.plがありません。');
	}
	require 'lib/makepage.pl';
	&Del;
}
else{
	&Top
}

sub GetCookieRes{
my($name,$value,$pair,@pairs,$cookies);
$cookies=$ENV{'HTTP_COOKIE'};
@pairs=split(/;/,$cookies);
foreach $pair(@pairs){
	($name, $value)=split(/=/,$pair);
	$name=~s/ //g;
	$DUMMY{$name}=$value;
}
$DUMMY{$c_name}=~ s/\+/ /g;
$DUMMY{$c_name}=~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
@pairs=split(/,/,$DUMMY{$c_name});
foreach $pair(@pairs){
	($name, $value)=split(/\:/,$pair);
	$COOKIE{$name}=$value;
}
}

sub Ninsho{
my($re);

if($cap == 1){
	if(!-e 'lib/capt_simple.pl'){
		&Err('captha.plがありません。');
	}
	require 'lib/capt_simple.pl';
}
else{
	if(!-e 'lib/capt.pl'){
		&Err('captha.plがありません。');
	}
	require 'lib/capt.pl';
}

$re=&CheckAns($FORM{'key'},$FORM{'ans'});

if(!$re){
	&error('書き込みできません。');
}

}


sub Top{
my($skinline,$entrytr,$comtr,$catetr,$artr,$enlist,$comlist,$arlist,$catelist,

);
unless(open(HTML,$keitai_top)){
	&error("keitai_topが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

if($skinline=~/<!--entrystart-->(.*?)<!--entryend-->/s){
	$entrytr=$1;
}
if($skinline=~/<!--comstart-->(.*?)<!--comend-->/s){
	$comtr=$1;
}
if($skinline=~/<!--catestart-->(.*?)<!--cateend-->/s){
	$catetr=$1;
}
if($skinline=~/<!--arstart-->(.*?)<!--arend-->/s){
	$artr=$1;
}


$enlist=&ReadEntry(\$entrytr);
$comlist=&ReadCom(\$comtr);
$catelist=&ReadCate("","",\$catetr);
$arlist=&ReadAr("","",\$artr);

$skinline=~s/<!--entrystart-->.*?<!--entryend-->/$enlist/s;
$skinline=~s/<!--comstart-->.*?<!--comend-->/$comlist/s;
$skinline=~s/<!--arstart-->.*?<!--arend-->/$arlist/s;
$skinline=~s/<!--catestart-->.*?<!--cateend-->/$catelist/s;


print "Content-type: text/html\n\n";
print $skinline;

exit;

}

sub ReadEntry{
my($ref,$i,$line,$tr_d,$id,$title,$link);
$ref=$_[0];

unless(open(FILE,$entrylog)){
	&error("$entrylogが開けません。");
}
$i=0;
$line="";
while(<FILE>){
	$tr_d=${$ref};
	($id,$title)=split(/,/,$_);
	$link="<a href=\"$script?mode=entry&id=$id\">$title</a>";
	$tr_d=~s/<!--entry-->/$link/;
	$line.=$tr_d;
	$i++;
	if($i >= $k_entopmax){
		last;
	}
}

return $line;

}

sub ReadCom{
my($ref,$i,$line,$tr_d,
$id,$no,$oyatitle,$name,$title,$email,$page,$link,
);
$ref=$_[0];

unless(open(FILE,$comlog)){
	&error("$comlogが開けません。");
}
$i=0;
$line="";
while(<FILE>){
	$tr_d=${$ref};
	($id,$no,$oyatitle,$name,$title,$email,$page)=split(/,/,$_);
	$link="<a href=\"$script?mode=entry&id=$id\">$title</a>";
	$tr_d=~s/<!--com-->/$link/;
	$line.=$tr_d;
	$i++;
	if($i >= $k_entopmax){
		last;
	}
}
close FILE;

return $line;
}

sub ReadAr{
my($mode,$m_d,$ref,$i,$line,$m,$n,$yr,$mn,$link,$tr_d,

);
$mode=$_[0];
$m_d=$_[1];
$ref=$_[2];

unless(open(ALOG,$arlog)){
	&error("$arlogが開けません。");
}
$i=0;
$line="";
while(<ALOG>){
	($m,$n)=split(/,/,$_);
	if($mode eq "omit" && $m == $m_d){
		next;
	}
	$tr_d=${$ref};
	$yr=substr($m,0,4);
	$mn=substr($m,4,2);
	$link="<a href=\"$script?mode=archive&m=$m\">$yr年$mn月($n)</a>";
	$tr_d=~s/<!--ar-->/$link/;
	$line.=$tr_d;

	$i++;
	if($i >= $k_artopmax){
		last;
	}
}
close ALOG;


return($line);

}

sub ReadCate{
my($mode,$cateid,$ref,$hd,$line,$cid,$n,$c,$tr_d,$link,$i,
);
$mode=$_[0];
$cateid=$_[1];
$ref=$_[2];

unless(open(FILE,$categorylog)){
	&error("$categorylogが開けません。");
}
$hd=<FILE>;
$line="";
while(<FILE>){
	($cid,$n,$c)=split(/,/,$_);
	if($mode eq "omit" && $cid == $cateid){
		next;
	}
	$tr_d=${$ref};
	$link="<a href=\"$script?mode=category&category=$cid\">$n</a>";
	$tr_d=~s/<!--category-->/$link/;

	$line.=$tr_d;
	$i++;
	if($i >= $k_catetopmax){
		last;
	}
}
close FILE;

return $line;
}

sub Entry{
my($m,$yr,$mn,$len,$file,$flag,
$i,$entryline,
$j,$idx,$mm,@files,$jj,$q,$f,$hd,$enum,$n_fname,$next,$fh,$f_fname,$former,
$skinline,
$no,$day,$time,$category,$comcount,$tbcount,$name,$title,$email,$message,$img,
$pagetmp,$no_f,$day_f,$d,$title_f,$fid,$flink,$fline,
$no_n,$day_n,$title_n,$nid,$nlink,$nline,$sub,$ref,$cno,
$tno,$no_d,$ping_url,$excerpt,$url,$blog_name,$date,$host,$tr_d,
$link,$tbline,$tbtr,$comline,$comtr,$ans,$key,$tag
);

$m=substr($FORM{'id'},0,6);
$yr=substr($m,0,4);
$mn=substr($m,4,2);
$len=length $FORM{'id'};
$no=substr($FORM{'id'},6,$len-6);


$file=$logdir.$m.'.log';

unless(open(FILE,$file)){
	&error("$fileが開けません。");
}
$hd=<FILE>;
($enum)=split(/,/,$hd);
$flag=0;
$i=0;
while(<FILE>){
	$i++;
	($no_d)=split(/,/,$_);
	if($no_d == $no){
		$entryline=$_;
		$flag=1;
		if(!eof){
			$former=<FILE>;
		}
		last;
	}
	$next=$_;
}
close FILE;

if(!$flag){
	$next="";
}


if($i == 1 || $i == $enum){
	if(!open(ALOG,$arlog)){
		&error("$arlogが開けません。");
	}
	$j=0;
	$flag=0;
	$idx=0;
	while(<ALOG>){
		($mm)=split(/,/,$_);
		$files[$idx]=$mm;
		$idx++;
		if($flag){
			last;
		}
		if($mm == $m){
			$jj=$j;
			$flag=1;
		}
		$j++;

	}

	close ALOG;
	if($i == 1){
		$j=$jj-1;
		for($q = $j;$q >= 0;$q--){
			$f=$files[$q];
			$f.='.log';
			if(-e "$logdir$f"){
				unless(open(FILE,"$logdir$f")){
					&error("$logdir$fが開けません。");
				}
				$hd=<FILE>;
				($enum)=split(/,/,$hd);
				if(!$enum){
					close FILE;
					next;
				}
				else{
					$n_fname=$f;
					$next=<FILE>;
					close FILE;
					last;
				}
			}
		}
	}
	else{

		$j=$jj+1;
		for($q = $j;$q < scalar(@files);$q++){
			$f=$files[$q];
			$f.='.log';
			if(-e "$logdir$f"){
				unless(open(FILE,"$logdir$f")){
					&error("$logdir$fが開けません。");
				}
				$hd=<FILE>;
				$fh=*FILE;
				($enum)=split(/,/,$hd);
				if(!$enum){
					close FILE;
					next;
				}
				else{
					$f_fname=$f;
					$former=&BackRead($fh);
					close FILE;
					last;
				}
			}
		}
	}

}


unless(open(HTML,$keitai_entry)){
	&error("keitai_entryが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

($no,$day,$time,$category,$comcount,$tbcount,$name,$title,$email,$message,$img)=split(/,/,$entryline);



$date=$yr.'.'.$mn.'.'.$day.' '.$time;
if($email){
	$name="<a href=\"mailto:$email\">$name</a>";
}

#@img=split(/<>/,$img);
#$updir=&GetImgPath($yr,$mn);
#foreach(@img){
#	($img,$w,$h)=split(/:/,$_);
#	$imgline.="<a href=\"$updir$img\">画像</a><br>\n";
#}


$pagetmp="";
if($former){
	($no_f,$day_f,$d,$d,$d,$d,$d,$title_f)=split(/,/,$former);
	if($f_fname){
		($fid)=split(/\./,$f_fname);
		$flink=$script."?mode=entry&id=$fid$no_f";
	}
	else{
		$flink=$script."?mode=entry&id=$m$no_f";
	}
	$fline="<a href=\"$flink\">≪前の記事<\/a>";
	$pagetmp.=$fline;
}

if($next){
	($no_n,$day_n,$d,$d,$d,$d,$d,$title_n)=split(/,/,$next);
	if($n_fname){
		($nid)=split(/\./,$n_fname);
		$nlink=$script."?mode=entry&id=$nid$no_n";
	}
	else{
		$nlink=$script."?mode=entry&id=$m$no_n";
	}
	if($former){
		$pagetmp.=" ";
	}
	$nline="<a href=\"$nlink\">次の記事≫<\/a>";
	$pagetmp.=$nline;
}



$skinline=~s/<!--date-->/$date/;
$skinline=~s/<!--name-->/$name/;
$skinline=~s/<!--title-->/$title/;
$skinline=~s/<!--message-->/$message/;
#$skinline=~s/<!--upfile-->/$imgline/;
$skinline=~s/<!--page-->/$pagetmp/;

if($useres){
	&GetCookieRes;
	$sub="Re: $title";
	$skinline=~s/#title/$sub/;
	$skinline=~s/#name/$COOKIE{'name'}/;
	$skinline=~s/#email/$COOKIE{'email'}/;
	$skinline=~s/#home/$COOKIE{'home'}/;
	$skinline=~s/#pass/$COOKIE{'pass'}/;
	$skinline=~s/#year/$yr/;
	$skinline=~s/#mon/$mn/;
	$skinline=~s/#no/$no/;
	
	if($skinline=~/<!--comstart-->(.*?)<!--comend-->/s){
		$comtr=$1;
	}
	
	
	$ref=&GetCom($m,$no);
	$comline="";
	foreach(@{$ref}){
		($cno,$no_d,$name,$title,$email,$url,$date,$message)=split(/,/,$_);
		$link="<a href=\"$script?mode=comment&id=$FORM{'id'}&cno=$cno\">$title</a>";
		$tr_d=$comtr;
		$tr_d=~s/<!--com-->/$link/;
		$comline.=$tr_d;
	}
	$skinline=~s/<!--comstart-->.*?<!--comend-->/$comline/s;
	if($cap){
		if($cap == 1){
			if(!-e 'lib/capt_simple.pl'){
				&error("capt_simple.plがありません。");
			}
			require 'lib/capt_simple.pl';
		}
		elsif($cap == 2){
			if(!-e 'lib/capt.pl'){
				&error("capt.plがありません。");
			}
			require 'lib/capt.pl';
		}
		$ans=&MakeAns;
		$key=&MakeKey($ans);
		$tag="文字入力<br><div style=\"text-align:center;padding:2px;width:60px;color:#000000;font-weight:bold;margin:2px 0px 2px 0px;border-width:1px;border-color:#000000;border-style:solid\">$ans</div><input type=\"text\" name=\"ans\" size=\"8\"><input type=\"hidden\" name=\"key\" value=\"$key\"><br>";
		$skinline=~s/<!--capt-->/$tag/;
	}
}
else{
	$skinline=~s/<!--formstart-->.*?<!--\/formend-->//s;
}

if($tbuse){
	if($skinline=~/<!--tbstart-->(.*?)<!--tbend-->/s){
		$tbtr=$1;
	}
	$ref=&GetTb($m,$no);
	$tbline="";
	foreach(@{$ref}){
		($tno,$no_d,$ping_url,$title,$excerpt,$url,$blog_name,$date,$host)=split(/,/,$_);
		$link="<a href=\"$script?mode=tb&id=$FORM{'id'}&tno=$tno\">$title</a>";
		$tr_d=$tbtr;
		$tr_d=~s/<!--tb-->/$link/;
		$tbline.=$tr_d;
	}
	$skinline=~s/<!--tbstart-->.*?<!--tbend-->/$tbline/s;
}
else{
	$skinline=~s/<!--tb-->.*?<!--\/tb-->//s;
}



print "Content-type: text/html\n\n";
print $skinline;

exit;



}




sub Comment{
my($m,$len,$no,$yr,$mn,$updir,$ref,$num,$i,$idx,$flag,
$cno,$count,$tmp,@new,$skinline,
$comtr,$name,$title,$email,$url,$date,$message,$img,$w,$h,$href,$href2,
$real_w,$real_h,$w_o,$imgfile,$link,$pagetmp,$comline,
$tr_d,$imge,
);


$m=substr($FORM{'id'},0,6);
$len=length $FORM{'id'};
$no=substr($FORM{'id'},6,$len-6);

$yr=substr($m,0,4);
$mn=substr($m,4,2);
$updir=&GetImgPath($yr,$mn);

$ref=&GetCom($m,$no);

$num=scalar(@{$ref});
$i=0;
$idx=0;
foreach(@{$ref}){
	$flag=0;
	$i++;
	($cno)=split(/,/,$_);
	if($cno == $FORM{'cno'}){
		$flag=1;
		$count=$i;
		$tmp=$_;
	}
	if(!$flag){
		$new[$idx]=$_;
		$idx++;
	}
}


unless(open(HTML,$keitai_com)){
	&error("keitai_comが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

if($skinline=~/<!--comstart-->(.*?)<!--comend-->/s){
	$comtr=$1;
}

($cno,$no,$name,$title,$email,$url,$date,$message,$img)=split(/,/,$tmp);

if($img){
	($img,$w,$h)=split(/:/,$img);
	$href="";
	$href2="";
	if($w > $w_max_res) {
		$real_w=$w+40;
		$real_h=$h+40;
		$w_o=$w;
		$w=$w_max;
		$h=int($w*$h/$w_o);
		$href="<a href=\"$updir$img\">";
		$href2="</a>";
	}
	$imgfile="<div>".$href."<img src=\"$updir$img\" width=\"$w\" height=\"$h\" border=\"0\">".$href2."</div>";
}

$skinline=~s/#id/$FORM{'id'}/;
$skinline=~s/<!--name-->/$name/;
$skinline=~s/<!--title-->/$title/;
$skinline=~s/<!--upfile-->/$imgfile/;
$skinline=~s/<!--message-->/$message/;
$skinline=~s/<!--date-->/$date/;

$link="<a href=\"$script?mode=delform&m=$m&cno=$cno&no=$no\">削除</a>";
$skinline=~s/<!--del-->/$link/;


$pagetmp="";
if($num > 1 && $count != 1){
	$idx=$count-2;
	($cno)=split(/,/,$new[$idx]);
	$pagetmp.="<a href=\"$script?mode=comment&id=$FORM{'id'}&cno=$cno\">前のｺﾒﾝﾄ<\/a>";

}
if($count < $num){
	$idx=$count;
	($cno)=split(/,/,$new[$idx]);
	$pagetmp.="<a href=\"$script?mode=comment&id=$FORM{'id'}&cno=$cno\">次のｺﾒﾝﾄ<\/a>";
}


$comline="";
foreach(@new){
	($cno,$no,$name,$title,$email,$url,$date,$message,$img)=split(/,/,$_);
	$tr_d=$comtr;
	$link="<a href=\"$script?mode=comment&id=$FORM{'id'}&cno=$cno\">$title</a>";

	$tr_d=~s/<!--com-->/$link/;

	if($img){
		($img,$w,$h)=split(/:/,$img);
		$href="";
		$href2="";
		if($w > $w_max_res) {
			$real_w=$w+40;
			$real_h=$h+40;
			$w_o=$w;
			$w=$w_max;
			$h=int($w*$h/$w_o);
			$href="<a href=\"$updir$img\">";
			$href2="</a>";
		}
		$imge="<div>".$href."<img src=\"$updir$img\" width=\"$w\" height=\"$h\" border=\"0\">".$href2."</div>";
		$tr_d=~s/<!--upfile-->/$imge/;
	}

	$comline.=$tr_d;

}


$skinline=~s/<!--page-->/$pagetmp/;
$skinline=~s/<!--comstart-->.*?<!--comend-->/$comline/s;

print "Content-type: text/html\n\n";
print $skinline;

exit;

}


sub Tb{
my($m,$len,$no,$file,$ref,$num,$i,$idx,$flag,$tno,$tmp,@new,
$skinline,
$ping_url,$title,$excerpt,$url,$blog_name,$date,$host,
$pagetmp,$tbline,$tr_d,$link,$count,$tbtr
);

$m=substr($FORM{'id'},0,6);
$len=length $FORM{'id'};
$no=substr($FORM{'id'},6,$len-6);
$file=$logdir.$m.'.log';

$ref=&GetTb($m,$no);

$num=scalar(@{$ref});
$i=0;
$idx=0;
foreach (@{$ref}){
	$flag=0;
	$i++;
	($tno)=split(/,/,$_);
	if($tno == $FORM{'tno'}){
		$tmp=$_;
		$flag=1;
		$count=$i;
	}
	if(!$flag){
		$new[$idx]=$_;
		$idx++;
	}
}


unless(open(HTML,$keitai_tb)){
	&error("keitai_tbが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

if($skinline=~/<!--tbstart-->(.*?)<!--tbend-->/s){
	$tbtr=$1;
}
($tno,$no,$ping_url,$title,$excerpt,$url,$blog_name,$date,$host)=split(/,/,$tmp);

$skinline=~s/#id/$FORM{'id'}/;
$skinline=~s/<!--name-->/$blog_name/;
$title="<a href=\"$url\">$title</a>";
$skinline=~s/<!--title-->/$title/;
$skinline=~s/<!--date-->/$date/;
$skinline=~s/<!--message-->/$excerpt/;

$pagetmp="";
if($num > 1 && $count != 1){
	$idx=$count-2;
	($tno)=split(/,/,$new[$idx]);
	$pagetmp.="<a href=\"$script?mode=tb&id=$FORM{'id'}&tno=$tno\">前のﾄﾗｯｸﾊﾞｯｸ<\/a>";

}
if($count < $num){
	$idx=$count;
	($tno)=split(/,/,$new[$idx]);
	$pagetmp.="<a href=\"$script?mode=tb&id=$FORM{'id'}&tno=$tno\">次のﾄﾗｯｸﾊﾞｯｸ<\/a>";
}

$tbline="";
foreach(@new){
	($tno,$no,$ping_url,$title,$excerpt,$url,$blog_name,$date,$host)=split(/,/,$_);
	$tr_d=$tbtr;
	$link="<a href=\"$script?mode=tb&id=$FORM{'id'}&tno=$tno\">$title</a>";
	$tr_d=~s/<!--tb-->/$link/;
	$tbline.=$tr_d;
}


$skinline=~s/<!--tbstart-->.*?<!--tbend-->/$tbline/s;

$skinline=~s/<!--page-->/$pagetmp/;

print "Content-type: text/html\n\n";
print $skinline;
exit;
}



sub Category{
my(
$hd,$cid,$n,$c,$allcount,$file,$mm,
$oya,$start,$end,
$allnum,$pageflag,$flag,$i,$skinline,$head,$table,$footer,$m,
$yr,$mn,$logfile,$cnt,$j,$no,$day,$time,$category,$page_next,$page_mack,$pagetmp,$catetr,$catelist,$link,
$page_back,%CNT

);


unless(open(FILE,$categorylog)){
	&error("$categorylogが開けません。");
}
$hd=<FILE>;
while(<FILE>){
	($cid,$n,$c)=split(/,/,$_);
	if($cid == $FORM{'category'}){
		$allcount=$c;
		last;
	}
}
close FILE;

$file=$catedir.$FORM{'category'}.'.log';
unless(open(FILE,$file)){
	&error("$fileが開けません。");
}
while(<FILE>){
	($mm,$c)=split(/,/,$_);
	$CNT{$mm}=$c;
}
close FILE;


$oya=$allcount;

$pagemax=1;

$start=$FORM{'page'}+1;
$end=$FORM{'page'}+$pagemax;


$allnum=0;
$pageflag=0;
$flag=0;
$i=0;

unless(open(HTML,$keitai_cate)){
	&error("keitai_cateが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

($head,$table,$footer)=&Cut2(\$skinline);

print "Content-type: text/html\n\n";

print $head;

unless(open(ALOG,$arlog)){
	&error("$arlogが開けません。");
}
while(<ALOG>){
	($m)=split(/,/,$_);
	$yr=substr($m,0,4);
	$mn=substr($m,4,2);
	$logfile=$m.'.log';
	$cnt=$CNT{$m};

	if(!$cnt){
		next;
	}
	if(!$pageflag){
		$allnum+=$cnt;
		if($allnum >= $start){
			$pageflag=1;
			$i=$allnum-$cnt;
		}
		else{
			next;
		}
	}

	unless(open(FILE,"$logdir$logfile")){
		&error("$logdir$logfileが開けません。");
	}
	$hd=<FILE>;

	$j=0;
	while(<FILE>){
		($no,$day,$time,$category)=split(/,/,$_);
		if($category == $FORM{'category'}){
			$i++;
			$j++;
		}
		else{
			next;
		}
		if($i > $end){
			$flag=1;
			last;
		}
		if($i < $start){
			next;
		}
		&MOutput2(\$_,$m,\$table);
		if($i == $end){
			$flag=1;
			last;
		}
		if($i >= $allcount){
			$flag=1;
			last;
		}
		if($j == $cnt){
			last;
		}
	}
	close FILE;
	if($flag){
		last;
	}

}
close ALOG;



$page_next=$FORM{'page'}+1;
$page_back=$FORM{'page'}-1;

$pagetmp="";
if($page_next < $oya){
	$link="$script?mode=category&category=$FORM{'category'}&page=$page_next";
	$pagetmp.="<a href=\"$link\">≪前の記事</a>&nbsp;&nbsp;";

}
if($page_back >= 0){
	$link="$script?mode=category&category=$FORM{'category'}&page=$page_back";
	$pagetmp.="<a href=\"$link\">次の記事≫</a>&nbsp;&nbsp;";

}

if($footer=~/<!--catestart-->(.*?)<!--cateend-->/s){
	$catetr=$1;
}

$catelist=&ReadCate("omit",$FORM{'category'},\$catetr);

$footer=~s/<!--catestart-->.*?<!--cateend-->/$catelist/s;
$footer=~s/<!--page-->/$pagetmp/;

print $footer;


exit;

}



sub MOutput2{
my($m,
$no,$day,$tm,$category,$comcount,$tbcount,$name,$title,$email,$message,$img,
$yr,$mn,$date,$comlink,$tblink,$id
);

$m=$_[1];
$table_d=${$_[2]};

($no,$day,$tm,$category,$comcount,$tbcount,$name,$title,$email,$message,$img)=split(/,/,${$_[0]});

if($email){
	$name="<a href=\"mailto:$email\">$name</a>";
}

$id=$m.$no;

if($comcount eq ""){
	$comcount=0;
}
if($tbcount eq ""){
	$tbcount=0;
}

$table_d=~s/<!--title-->/$title/;
$table_d=~s/<!--upfile-->/$img/;
$table_d=~s/<!--message-->/$message/;
$table_d=~s/<!--name-->/$name/;

$yr=substr($m,0,4);
$mn=substr($m,4,2);
$date="$yr.$mn.$day $tm";
$table_d=~s/<!--date-->/$date/;

$comlink="<a href=\"$script?mode=entry&id=$id#comment\">ｺﾒﾝﾄ($comcount)</a>";
$table_d=~s/<!--comment-->/$comlink/;

if($tbuse){
	$tblink="<a href=\"$script?mode=entry&id=$id#tb\">ﾄﾗｯｸﾊﾞｯｸ($tbcount)</a>";
	$table_d=~s/<!--tb-->/$tblink/;
}

print $table_d;

}



sub Archive{
my(
$file,$hd,$enum,$oya,$pagemax,$start,$end,$skinline,$head,$table,$footer,
$i,$page_next,$page_back,$pagetmp,$link,$artr,$arlist
);


$file=$logdir.$FORM{'m'}.'.log';

unless(open(ALOG,$file)){
	&error("$fileが開けません。");
}
$hd=<ALOG>;
($enum)=split(/,/,$hd);
$oya=$enum;

$pagemax=1;

$start=$FORM{'page'}+1;
$end=$FORM{'page'}+$pagemax;

unless(open(HTML,$keitai_ar)){
	&error("keitai_arが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);


($head,$table,$footer)=&Cut2(\$skinline);

print "Content-type: text/html\n\n";

print $head;

$i=0;
while(<ALOG>){
	$i++;
	if($i > $end){
		last;
	}
	if($i < $start){
		next;
	}
	&MOutput2(\$_,$FORM{'m'},\$table);

}
close ALOG;


$page_next=$FORM{'page'}+1;
$page_back=$FORM{'page'}-1;

$pagetmp="";


if($page_next < $oya){
	$link="$script?mode=archive&m=$FORM{'m'}&page=$page_next";
	$pagetmp.="<a href=\"$link\">≪前の記事</a>&nbsp;&nbsp;";

}
if($page_back >= 0){
	$link="$script?mode=archive&m=$FORM{'m'}&page=$page_back";
	$pagetmp.="<a href=\"$link\">次の記事≫</a>&nbsp;&nbsp;";

}

if($footer=~/<!--arstart-->(.*?)<!--arend-->/s){
	$artr=$1;
}

$arlist=&ReadAr("omit",$FORM{'m'},\$artr);

$footer=~s/<!--arstart-->.*?<!--arend-->/$arlist/s;
$footer=~s/<!--page-->/$pagetmp/;

print $footer;
exit;

}


sub End{
my($skinline);
unless(open(HTML,$keitai_thanks)){
	&error("keitai_thanksが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

$skinline=~s/<!--msg-->/$_[0]/;

print "Content-type: text/html\n\n";
print $skinline;

exit;
}

sub DelForm{
&header;
print <<EOM;
<div>
パスワードを入力してボタンを押してください。
</div>
<form action="$script" method="POST">
<input type="hidden" name="mode" value="usrdel">
<input type="hidden" name="m" value="$FORM{'m'}">
<input type="hidden" name="cno" value="$FORM{'cno'}">
<input type="hidden" name="no" value="$FORM{'no'}">
<table>
<tr>
<td>パスワード</td><td><input type="password" name="pass" size="10"></td>
</tr>
</table>
<input type="submit" value="削除">
</form>
</body>
</html>
EOM

exit;
}


sub header{
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>$blogtitle</title>
</head>
<body text="$t_color" bgcolor="$b_color">
EOM
}

sub error{

&header;

print <<EOM;
<center>
<br>
<br>
<font color="#ff0000">ERROR</font>
<br>
<br>
EOM

print"$_[0]\n";

print <<EOM;
</center>
</body>
</html>
EOM
exit;

}

exit;