#!/usr/bin/perl


#--------ライブラリ読込み------------------------

if(!-e 'lib/conf.pl'){
	&error("conf.plがありません。");
}
require 'lib/conf.pl';

if(!-e 'lib/conf2.cgi'){
	&error("conf2.cgiがありません。");
}
require 'lib/conf2.cgi';

if(!-e 'lib/functions.pl'){
	&error("functions.plがありません。");
}
require 'lib/functions.pl';

if(!-e 'lib/res.pl'){
	&error("res.plがありません。");
}
require 'lib/res.pl';

#----------------------------------------------

$script='res.cgi';
$maxsize=1000000;

if(!&SuCheck){
	$su=0;
}

$FORM{'page'}=0;



if($resup && $ENV{'CONTENT_TYPE'} =~ /multi/){
	&DecodeMulti;
}
else{
	&Dcd;
}

sub DecodeMulti{
my($ref,$in_ref,$incfn_ref,$inct_ref,
$name,$value,
$o,$d,$upflag,$upnflag,$filename,$ctype,$okflag,
$csvfilename,$t_fname,$na,@tmp,$ext,$dum,$app,$imgfilename,$upidx
);

unless(-e "lib/cgi_lib.pl"){
	&error("cgi_lib.plがありません。");
}
require 'lib/cgi_lib.pl';

($ref,$in_ref,$incfn_ref,$inct_ref)=&ReadParse;
$upidx=0;
foreach $name(@{$ref}){
	if ($name !~/^upfile/) {
		$value=${$in_ref}{$name};
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		$value=~s/"/&quot;/g;
		$value=~s/</&lt;/g;
		$value=~s/>/&gt;/g;
		if($name eq "message"){
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		else{
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		$FORM{$name}=$value;
	}
	else{
		$upflag=0;
		$upnflag=0;
		$filename="";
		$ctype="";
		$okflag=0;
		$upnflag=1;
		$filename=${$incfn_ref}{$name};
		$ctype=${$inct_ref}{$name};
		$CTYPE{$name}=$ctype;
		if($filename){
			($dum,$app)=split(/\//,$ctype);
			if($app eq "gif"){
				$ext='.gif';
				$okflag=1;
			}
			elsif($app eq "pjpeg" || $app eq "jpeg"){
				$ext='.jpg';
				$okflag=1;
			}
			if(!$okflag){
				&error("アップできる画像はJPEG、GIFファイルのみです。");
			}
			$imgfile=time.$$.$ext;
			$name_d=$name;
			$name_d=~s/upfile//;
			$imgfilename = $tmpimgdir.$imgfile;
			$UPFNAME[$upidx]=$imgfile;
			$upidx++;
			$FNAME{$name_d}=$filename;
			unless(open(IMAGE,">$imgfilename")){
				&error("画像のアップロードに失敗しました");
			}
			binmode(IMAGE);
			binmode(STDOUT);
			print IMAGE ${$in_ref}{$name};
			close(IMAGE);
			$upflag=1;
		}
	}
}

}


sub Dcd{
my($name,$value,$buff,@pairs,$pair);

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'} > $maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	@pairs=split(/&/,$buff);
	foreach $pair(@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		$value=~s/"/&quot;/g;
		$value=~s/</&lt;/g;
		$value=~s/>/&gt;/g;
		if($name eq "message"){
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		else{
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}

		$FORM{$name}=$value;
	}
}

}

if($FORM{'mode'} eq "regist"){
	if($cap){
		&Ninsho;
	}
	if($rescheck){
		&TmpRegist;
	}
	else{
		if(!-e 'lib/makepage.pl'){
			&error('makepage.plがありません。');
		}
		require 'lib/makepage.pl';
		&Regist;
	}
}
if($FORM{'mode'} eq "check"){
	&Check;
}
if($FORM{'mode'} eq "delform"){
	&DelForm;
}
if($FORM{'mode'} eq "usrdel"){
	if(!-e 'lib/makepage.pl'){
		&error('makepage.plがありません。');
	}
	require 'lib/makepage.pl';
	&Del;
}
if($FORM{'mode'} eq "icon"){
	&Icon;
}


sub Ninsho{
my($re);

if($cap == 1){
	if(!-e 'lib/capt_simple.pl'){
		&Err('captha.plがありません。');
	}
	require 'lib/capt_simple.pl';
}
else{
	if(!-e 'lib/capt.pl'){
		&Err('captha.plがありません。');
	}
	require 'lib/capt.pl';
}

$re=&CheckAns($FORM{'key'},$FORM{'ans'});

if(!$re){
	&Err('書き込みできません。');
}

}

sub GetURL{
my($yr,$mn,$no,$entrydir_d,$tdir,$url);
$yr=$_[0];
$mn=$_[1];
$no=$_[2];

$entrydir_d=$entrydir;

if($baseurl){
	$entrydir_d=~s/^\.\.\///;
	$tdir=$baseurl;
}

if($entrymode){
	if($su){
		$url=$tdir.$entrydir_d.$yr."/".$mn."/".$no.$htmlext;
	}
	else{
		$url=$tdir.$entrydir_d.$yr.$mn.$no.$htmlext;
	}
}
else{
	$url="read.cgi?mode=entry&id=$yr$mn$no";
}

return $url;
}


sub DelForm{
&header;
print <<EOM;
<div>
パスワードを入力してボタンを押してください。
</div>
<form action="$script" method="POST">
<input type="hidden" name="mode" value="usrdel">
<input type="hidden" name="m" value="$FORM{'m'}">
<input type="hidden" name="cno" value="$FORM{'cno'}">
<input type="hidden" name="no" value="$FORM{'no'}">
<table>
<tr>
<td>パスワード</td><td><input type="password" name="pass" size="10"></td>
</tr>
</table>
<input type="submit" value="削除">
</form>
</body>
</html>
EOM


exit;
}


sub DelEnd{

&header('end');
print <<EOM;
<div>
削除しました。
</div>
</body>
</html>
EOM

exit;
}

sub Check{
my($skinline,$head,$dummy,$table,$footer,$imgfile,
@tmp,$ext,$w,$h,$href,$href2,$real_w,$real_h,$w_o,$imge,
$sec,$min,$hour,$day,$mon,$year,$date,$bodytag,$imgfilename
);

unless(open(HTML,$skin1)){
	&error("$skin1が開けません。ファイルを確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);

($head,$dummy) = split(/<!--resstart-->/, $skinline);
if($head eq ""){
	&error("スキンに&lt;!--resstart--&gt;が書かれていません。");
}
($table,$footer) = split(/<!--resend-->/, $dummy);
if($table eq ""){
	&error("スキンに&lt;!--resend--&gt;が書かれていません。");
}
if($head=~/(<body.*?>)/i){
	$bodytag=$1;
}
else{
	&error("スキンにbodyタグが書かれていません。");
}
($head)=split(/<\/head>/i,$head);
if($head eq ""){
	&error("スキンに&lt;/head&gt;が書かれていません。");
}
$head.="</head>";
$head.=$bodytag;



if($UPFNAME[0]){
	$imgfile=$UPFNAME[0];
	$imgfilename=$tmpimgdir.$imgfile;
	@tmp=split(/\./,$imgfile);
	$ext=$tmp[$#tmp];
	($w,$h)=&GetSize($ext,$imgfilename);
	$href="";
	$href2="";
	if($w > $w_max_res) {
		$real_w=$w+40;
		$real_h=$h+40;
		$w_o=$w;
		$w=$w_max;
		$h=int($w*$h/$w_o);
		$href="<a href=\"javascript:void(0)\" onclick=\"OpenWin('$tmpimgdir$imgfile',$real_w,$real_h);\">";
		$href2="</a>";
	}
	$imge=$href."<img src=\"$tmpimgdir$imgfile\" width=\"$w\" height=\"$h\" border=\"0\">".$href2;
	$table=~s/<!--upfile-->/$imge/;
}

if($FORM{'icon'}){
	&InIcon('check',\$FORM{'message'});
}

$table=~s/<!--title-->/$FORM{'title'}/;
$table=~s/<!--message-->/$FORM{'message'}/;
$table=~s/<!--name-->/$FORM{'name'}/;


($sec,$min,$hour,$day,$mon,$year)=localtime(time);
$mon++;
$year=$year+1900;
$hour=sprintf("%02d",$hour);
$min=sprintf("%02d",$min);
$mon=sprintf("%02d",$mon);
$day=sprintf("%02d",$day);

$date="${year}.${mon}.${day} ${hour}:${min}";
$table=~s/<!--date-->/$date/;

$table="<div id=\"main\" style=\"text-align:left;padding:20px;\">".$table."</div>";


print "Content-type: text/html\n\n";
print $head;
print $table;

print "</body>\n</html>\n";

exit;
}

sub Icon{
my($iconref);

$iconref=&MakeIcon;

print "Content-type: text/plain\n\n";
print ${$iconref};
exit;

}

sub End{
my($url);
$url=$_[0];

print <<EOM;
Content-type: text/html

<html>
<head>
<title></title>
<script type="text/javascript">
function Jump(){
	location.href="$url";

}
</script>
</head>
<body onload="Jump();">
</body>
</html>
EOM

exit;
}


sub TmpEnd{

print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<script type="text/javascript">
function Alert(){
	alert('仮投稿しました。管理人の承認ののち、反映されます。');
}
</script>
</head>
<body onload="Alert();">
</body>
</html>
EOM

exit;
}


sub Err{

print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<script type="text/javascript">
function Alert(e){
	alert(e);
}
</script>
</head>
<body onload="Alert('$_[0]');">
</body>
</html>
EOM

exit;
}


sub header{
my($on);

if($_[0] eq 'end'){
	$on=" onload=\"End();\"";
}

print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>管理画面</title>
<STYLE TYPE="text/css">
<!--
div,td{font-size:10pt}
-->
</STYLE>
<script type="text/javascript">
function End(){
	opener.location.reload();

}
</script>
</head>
<body$on>
EOM

}



sub error{

if($lockflag==1){
	close LOCK;
}

&header;

print <<EOM;
<div align="center">ERROR<br><br>
EOM

print"$_[0]\n";

print <<EOM;
</div>
</body>
</html>
EOM
exit;

}

exit;